
var last_sz = 100;

// get variable object reference (supports external calls)
function get_RV() {
 if ( typeof this.last_sz != 'undefined') return( this);
 // for external calls
 if ( typeof this.ownerDocument == 'undefined') return( null);
 var d = this.ownerDocument;
 if ( typeof d.defaultView == 'undefined') return( null);
 var dd = d.defaultView;
 if ( dd.last_sz == 'undefined') return( null);
 return( dd);  }

function act_rotate( _dir, _angle) {
 dv_svg_I.brd_rotate( _dir, _angle);
 return;  }

function id2perc( _el) {
 if ( typeof _el.id == 'undefined') return( null);
 if ( _el.id.substring( 0, 4) != 'perc') return( null);
 return( parseInt( _el.id.replace( 'perc', '')));  }

// find next percents based on ID suffix of 'perc'
function next_sz( _nowsz, _sign) {
 var ret = _nowsz;
 var r = dv_svg_I.get_child_by_id( this.document.rootElement, 'ruler');
 if ( r == null) return( ret);
 // scroll trough elements
 var p_B = 100;		// before (100% by default)
 var p_A = 0;		// after
 var tmpe = null;
 var tmpi = 0;
 var seen = 0;
 for ( var i = 0; i < r.childNodes.length; i++) {
   if ( ( tmpi = id2perc( r.childNodes[ i])) == null) continue;
   // set 'after'
   if ( tmpi < _nowsz && ( tmpi > p_B || p_B == 0)) p_B = tmpi;
   if ( tmpi > _nowsz && ( tmpi < p_A || p_A == 0)) p_A = tmpi;
   if ( tmpi == _nowsz) seen = 1;
 }
 if ( _sign == '-' && p_B != 0) ret = p_B;
 if ( _sign == '+' && p_A != 0) ret = p_A;
 return( ret); }

// update scale only
function set_scale_P( _percents) {
 var P = _percents;
 var r = dv_svg_I.get_child_by_id(  this.document.rootElement, 'ruler');
 if ( r == null) return;
 var ep = 0;
 for ( var i = 0; i < r.childNodes.length; i++) {
   if ( ( ep = id2perc( r.childNodes[ i])) == null) continue;
   r.childNodes[ i].setAttribute( 'class', ( ep <= P ? 'norm' : 'transp'));
 }
 return; }

// x_* - for external calls

// set exact view in percents
function x_set_P( _p) {
 var D = get_RV();
 if ( !D) return;
 set_scale_P( _p);
 dv_svg_I.brd_chSz( _p);
 D.last_sz = _p;
}

function x_set_scale_P( _percents) {
 set_scale_P( _percents);
}

// return current scale
function x_get_P( _root, _percents) {
 var D = get_RV();
 if ( !D) return( null);
 return( D.last_sz);  }

function x_get_next_P( _cur, _sign) {
 var for_P = _cur;
 if ( _cur == null) {
   var D = get_RV();
   if ( D == null) return( null);
   for_P = D.last_sz;  }
 return( next_sz( for_P, _sign));  }

// inc or dec view
function x_ch( _sign) {
 var D = get_RV();
 if ( !D) return;
 var new_sz = next_sz( D.last_sz, _sign);
 if ( new_sz == D.last_sz) return;
 x_set_P( new_sz);
 return;  }

function act_tibbits_opacity_sw() {
 dv_svg_I.tibbits_opacity_sw();
 return;  }


function set_regulator_callbacks( _doc) {
 _doc.rootElement.x_set_P = x_set_P;
 _doc.rootElement.x_get_P = x_get_P;
 _doc.rootElement.x_get_next_P = x_get_next_P;
 _doc.rootElement.x_set_scale_P = x_set_scale_P;
 _doc.rootElement.x_ch = x_ch;
}
