var MAX_ANGLE = 60;

function calc_angle( _val, _max) {
 var x = 0;
 if ( _max != 0) x = this.MAX_ANGLE / _max;
 return( _val * x); }

// x_* - for external calls

function x_set_type( _type) {
 var e_E = dv_svg_I.get_child_by_id( this, 'scale_E');
 var e_O = dv_svg_I.get_child_by_id( this, 'scale_O');
 switch ( _type) {
   case 'E':
   case 'W':
     e_E.setAttribute( 'visibility', 'visible');
     e_O.setAttribute( 'visibility', 'hidden');
     break;
   default:
     e_E.setAttribute( 'visibility', 'hidden');
     e_O.setAttribute( 'visibility', 'visible');
     break;
 }
}

function x_set_lbls( _volts, _vals) {
 var e = null;
 e = dv_svg_I.get_child_by_id( this, 'volt_lbl');
 if ( e) e.textContent = _volts + 'V';
 if ( typeof _vals.cons !== 'undefined') {
   e = dv_svg_I.get_child_by_id( this, 'cons_lbl');
   if ( e) e.textContent = _vals.cons + 'mA';
   e = dv_svg_I.get_child_by_id( this, 'scale_lbl');
   if ( e) e.textContent = _vals.have + 'mA';
 }
}

function x_set_arrow( _vals) {
 if ( typeof _vals.cons == 'undefined') return;
 var e = null;
 e = dv_svg_I.get_child_by_id( this, 'arrow_pointer');
 if ( !e) return;
 var angle = 0;
 angle = calc_angle( _vals.cons, Math.max( _vals.cons, _vals.have));
 r = 'rotate(' + angle + ', 107, 186.5)';
 e.setAttribute( 'transform', r);
 e = dv_svg_I.get_child_by_id( this, 'arrow_line');
 if ( !e) return;
 angle = calc_angle( _vals.have, Math.max( _vals.cons, _vals.have));
 r = 'rotate(' + angle + ', 107, 186.5)';
 e.setAttribute( 'transform', r);
}


function set_vmeter_callbacks( _doc) {
 _doc.rootElement.x_set_type = x_set_type;
 _doc.rootElement.x_set_lbls = x_set_lbls;
 _doc.rootElement.x_set_arrow = x_set_arrow;
}
