
 var dv_board = new new Class({
   initialize: function() {
     this.cur_board = null;		// obj
     this.cur_board_fname = null;
     this.phy_layout = new Array();
     this.cells = new Array();
     this.on_after_init = null;		// callback to do after init
     this.cur_angle = 0;		// current rotate angle
     this.old_attrs = null;
     this.saved_socks_settings = null;	// first filled on init
     this.cur_modules_opacity = 1;
   },

 load: function( _fname, _opts) {
   this.initialize();
   var board_fp = find_FN( FILES, _fname);
   if ( !board_fp) {
     alert( 'Board file \'' + _fname + '\' not found in resources');
     return( null);  }
   dv_board.cur_board_fname = new String( _fname).concat();
   var B = null;
   if ( typeof board_fp.parsed !== 'undefined') B = board_fp.parsed;
   if ( !B) {
     alert( 'Board file \'' + _fname + '\' have syntax errors');
     return( null);  }
   var Bgr = null;
   if ( typeof B.graphics !== 'undefined') Bgr = B.graphics;
   if ( !Bgr) {
     alert( 'Board \'' + _fname + '\' description lacks [graphics]');
     return( null);  }
   var Bsvg = null;
   if ( typeof Bgr.svg !== 'undefined') Bsvg = Bgr.svg;
   if ( !Bsvg) {
     alert( 'Board \'' + _fname + '\' lacks [graphics]->svg');
     return( null);  }
   var p = { cons: 0, have: 0, };
   p.cons = ( typeof B.p5v != 'undefined' ? B.p5v : 0);
   Vmeter0.set_V( p, 'O');
   p.cons = ( typeof B.pp15v != 'undefined' ? B.pp15v : 0);
   Vmeter1.set_V( p, 'O');
   p.cons = ( typeof B.pn15v != 'undefined' ? B.pn15v : 0);
   Vmeter2.set_V( p, 'O');
   var opts = [];
   if ( typeof _opts.svg_id != 'undefined') opts.id = _opts.svg_id;
   if ( typeof _opts.after_init != 'undefined') this.on_after_init = _opts.after_init;
   opts.onload = dv_board.do_init;
   this.cur_board = dv_svg.new_obj( Bsvg, '', '', opts);
   return( this.cur_board);
 },

 do_init: function( _e) {
   var doc = dv_svg.get_doc( this);
   if ( !doc) {
     alert( 'Board SVG have no root element?!');
     return;  }
   var file = dv_board.cur_board_fname;
   var fp = find_FN( FILES, file);
   if ( !fp) {
     alert( 'Board description file \'' + Bfile + '\' file not found');
     return;  }
   if ( !fp.parsed) {
     alert( 'Board description file may have syntax error(s)');
     return;  }
   dv_board.fill_socks_attrs( _e, doc, fp.parsed);
   dv_board.cells.empty();
   dv_board.phy_layout = [];
   if ( typeof doc.rootElement.phy_layout != 'undefined') {
     dv_board.phy_layout = doc.rootElement.phy_layout;
   }
   if ( typeof doc.rootElement.x_set_workspace != 'undefined') {
     doc.rootElement.x_set_workspace( 'W');	// I loaded it to workspace
   }
   dv_board.do_init_vmeters( _e, fp.parsed);
   // update svg options
   var pp = Project.parsed;
   if ( typeOf( pp.options) != 'null') {
     var ka = pp.options.getKeys();
     for ( var i = 0; i < ka.length; i++) {
       k = ka[i]; v = pp.options.get(k);
       doc.rootElement.x_option_set( k, v);
     }
   }
   if ( dv_board.on_after_init) dv_board.on_after_init();
 },

 do_init_vmeters: function( _e, _parsed) {
   var p = { cons:0, have:0 };
   p.cons = ( typeof _parsed.p5v != 'undefined' ? _parsed.p5v : 0);
   Vmeter0.set_V( p, 'O');
   p.cons = ( typeof _parsed.pp15v != 'undefined' ? _parsed.pp15v : 0);
   Vmeter1.set_V( p, 'O');
   p.cons = ( typeof _parsed.pn15v != 'undefined' ? _parsed.pn15v : 0);
   Vmeter2.set_V( p, 'O');
 },

 // add attributes, defined in board description file to socket nodes
 // for _isinitial==true  save values (default)
 // for _isinitial==false use default values+options case
 fill_socks_attrs: function( _e, _doc, _parsed) {
   var socks = dv_svg.get_child_by_id( _doc.rootElement, 'events');
   var B = new Hash( _parsed);
   var SSS = [];
   var Pp = null;
   var opts = null;
   if ( typeOf( Project.parsed)) Pp = Project.parsed;
   // opts != null after options change/update only
   if ( Pp && typeOf( Pp.options) != 'null') opts = Pp.options;
   // board is a parsed hash object
   B.each(function( _v, _k){
     var SS = {};
     var m = null;
     if ( !( m = _k.match(/sock(.*)/))) return;
     var el = _doc.getElementById( 's' + m[1]);
     if ( !el) return;
     SS.accept = _v.accept;
     SS.features = ( typeof _v.features == 'undefined' ? '-all' : _v.features);
     var lines = 'Y Y Y Y';
     var linesa = lines.split( ' ');
     if ( !dv_parse.get_bool( _v.line1, true)) linesa[0] = 'N';
     if ( !dv_parse.get_bool( _v.line2, true)) linesa[1] = 'N';
     if ( !dv_parse.get_bool( _v.line3, true)) linesa[2] = 'N';
     if ( !dv_parse.get_bool( _v.line4, true)) linesa[3] = 'N';
     lines = linesa[0].concat( ' ', linesa[1], ' ', linesa[2], ' ', linesa[3]);
     SS.lines = lines;
     var x = 'N';
     x = ( !dv_parse.get_bool( _v.serial, false) ? 'N' : 'Y');
     SS.serial = x;
     x = ( !dv_parse.get_bool( _v.interrupt, false) ? 'N' : 'Y');
     SS.interrupt = x;
     x = ( !dv_parse.get_bool( _v.poe, false) ? 'N' : 'Y');
     SS.poe = x;
     // fix: if return true -> need update options form
     if ( opts && _v.ifa) sock_limits.ifa2ss( _v.ifa, SS, opts);
     el.setAttribute( 'tib_accepts', SS.accept);
     el.setAttribute( 'tib_features', SS.features);
     el.setAttribute( 'tib_lines', SS.lines);
     el.setAttribute( 'tib_serial', SS.serial);
     el.setAttribute( 'tib_interrupt', SS.interrupt);
     el.setAttribute( 'tib_poe', SS.poe);
     SSS[ ( 's' + m[1])] = SS;
   },_doc);
 // fix: remove SSS
 },

 chSzPc: function( _percents, _set) {
   if ( !Project.svg) return( 100);
   var pc = parseFloat( _percents);
   var w = $('mainPanel').clientWidth;
   var h = $('mainPanel').clientHeight;
   resize_WH( w*pc/100, h*pc/100);
   return( pc);
 },

 rotate: function( _dir) {
   if ( !this.cur_board) return;
   // early versions of IE9 rotates buggy
//   if ( Browser.ie9) {
//     alert( 'Ask IE9 developers to fix rotation bug. Sorry about that.');
//     return;  }
   var doc = dv_svg.get_doc( this.cur_board);
   if ( !doc) return;
   var d_r = doc.rootElement;
   if ( !d_r) return;
   var B = doc.getElementById( 'whole_board');
   if ( !B) return;
   switch ( _dir) {
     case 'L':  this.cur_angle += -90;
       break;
     case 'R':  this.cur_angle += 90;
       break;
   }
   if ( Math.abs( this.cur_angle) == 360) this.cur_angle = 0;
   // if default view - clear transform and set viewbox to default
   if ( this.cur_angle == 0) {
     dv_svg.setA( B, 'transform', '');
     return;  }
   // not default - do transformations
   var t = '';
   // calculate center of an image...
   var def_vbox = '';
   def_vbox += dv_svg.getA( d_r, 'x', '0').replace( 'px', '') + ' ';
   def_vbox += dv_svg.getA( d_r, 'y', '0').replace( 'px', '') + ' ';
   def_vbox += dv_svg.getA( d_r, 'width', '0').replace( 'px', '') + ' ';
   def_vbox += dv_svg.getA( d_r, 'height', '0').replace( 'px', '');
   // if viewBox is not defined - use usual parameters
   var vbxs = dv_svg.getA( d_r, 'viewBox', def_vbox);
   if ( !vbxs) return;
   var vbxa = vbxs.split( ' ');
   if ( vbxa.length != 4) return;
   var vbx = [];
   vbx.push( parseFloat( vbxa[ 0]));
   vbx.push( parseFloat( vbxa[ 1]));
   vbx.push( parseFloat( vbxa[ 2]));
   vbx.push( parseFloat( vbxa[ 3]));
   // get real WxH
   var sz_x = ( vbx[ 2] - vbx[ 0]);
   var sz_y = ( vbx[ 3] - vbx[ 1]);
   // calc center
   var center_x = ( sz_x)/2 + vbx[ 0];
   var center_y = ( sz_y)/2 + vbx[ 1];
   // calc koeff
//   console.log( 'sz_x:' + sz_x + ' sz_y:'+sz_y + ' sz_y/sz_x:'+(sz_y/sz_x));
//   console.log( 'center x:' + center_x + ' y:' + center_y);
   var K = sz_y/sz_x;
   t = '';
   if ( this.cur_angle != 180) {
     var Km = K - 1;
     t += ' translate(' + (-center_x)*Km + ',' + (-center_y)*(Km) + ')';
     t += ' scale(' + K + ')';
   }
   t += ' rotate(' + this.cur_angle + ',' + center_x + ',' + center_y + ')';
   dv_svg.setA( B, 'transform', t);
//console.log( t);
   Regulator0.set_P( 100);
 },

 get_sock: function( _sid) {
   var doc = dv_svg.get_doc( this.cur_board);
   if ( !doc) {
     alert( 'get_sock_attrs DOC not found');
     return( null);  }
   var socks = dv_svg.get_child_by_id( doc.rootElement, 'events');
   if ( !socks) {
     alert( 'get_sock_attrs socks not found');
     return( null);  }
   return( doc.getElementById( _sid));
 },

 cell_busy_with: function( _sid) {
   for ( var i = 0; i < dv_board.cells.length; i++) {
     var e = dv_board.cells[i];
     // e { file, ... }
     if ( e.cell == _sid) return( e);
   }
   return( null);
 },

 xxx_del: function( _cell, _pcell, _file, _form, _angle) {
   var busy = dv_board.cell_busy_with( _cell);
//console.log( 'del from _cell:'+_cell);
   if ( busy != null) really_del_noonchange( _cell);
 },

 xxx_add: function( _cell, _pcell, _file, _form, _angle) {
   var busy = dv_board.cell_busy_with( _cell);
   if ( busy != null) {
     var t = 'Internal error: Attempted to place a Tibbit into an occupied socket ' + _cell + '. Please tell Tibbo about this error.';
     alert( t);
     dv_calc_cons.add( '<span style="color:Red">' + t + '</span>');  }
   var e = new Hash();
   e.set( 'cell', _cell);
   e.set( 'pcell', _pcell);
   e.set( 'file', _file);
   e.set( 'form', _form);
   e.set( 'angle', _angle);
//console.log( 'add');
//console.log( e);
   dv_board.cells.push( e);
 },

 // id _busydel - free occupied cells
 cells_busy_XXX: function( _cellid, _file, _form, _angle, _cbf) {
   // call _cbf on main cell
   _cbf( _cellid, _cellid, _file, _form, _angle);
   // set busy to neighbors if tibbit is big
   var needs = sock_limits.form_needs( _form, _angle);
   if ( needs.getLength() < 1) return;
   // find current cell (x,y) phy position
   var xy = sock_limits.get_phy_pos( _cellid);
   var cpos_x = xy.get( 'x');
   var cpos_y = xy.get( 'y');
   // if cell not found in phy
   if ( cpos_x < 0 || cpos_y < 0) {
     dv_cons.add( 'cell_busy_XXX(): cell ' + _cellid + ' not found in matrix');
     return;  }
   var m_x = 0;
   var m_y = 0
   var ka = needs.getKeys();
//console.log( 'cellid:'+_cellid+' form:'+_form+' cpos_x0:'+cpos_x+' cpos_y0:'+cpos_y);
//console.log( needs);
   var k = null;
   var v = null;
   var x0 = cpos_x;
   var x1 = cpos_x;
   var y0 = cpos_y;
   var y1 = cpos_y;
   // for each direction...set busy
   for ( var i = 0; i < ka.length; i++) {
     d = ka[i];  v = needs.get(k);
     if ( d == 'L') x0--;
     if ( d == 'R') x1++;
     if ( d == 'B') y0--;
     if ( d == 'U') y1++;
   }
//console.log( 'N '+x0+'.x.'+x1+' '+y0+'.y.'+y1);
   for ( var x = x0; x <= x1; x++) {
     for ( var y = y0; y <= y1; y++) {
       if ( cpos_x == x && cpos_y == y) continue;
       n = sock_limits.get_phy_xy( x, y);
       if ( n == null) continue;
      _cbf( n, _cellid, _file, _form, _angle);
//console.log( 'N x:'+x+' y:'+y);
     }
   }
   return;  },

 cells_busy_del_set: function( _cellid) {
   for ( var i = 0; i < dv_board.cells.length; i++) {
     var e = dv_board.cells[i];
     if ( e.pcell != _cellid) continue;
     dv_board.cells.erase( e);  i--;  }
   return;  },

 // it's called on general board change:
 // each del or add and options apply
 on_change: function() {
   // get all parent busy cells
   var PRJ = Project;
   var Bfp = find_FN( FILES, dv_board.cur_board_fname);
   // reset all variables
//   PRJ.parsed.empty();
   dv_calc_cons.set( '');
   var powers = new Hash();
   powers.set( 'p5v+',0);
   powers.set( 'p5v-',0);
   powers.set( 'p5v-state','O');
   powers.set( 'pp15v+',0);
   powers.set( 'pp15v-',0);
   powers.set( 'pp15v-state','O');
   powers.set( 'pn15v+',0);
   powers.set( 'pn15v-',0);
   powers.set( 'pn15v-state','O');
   var fp = null;
   var pbusy = [];
   var bom = new Hash();
   var socks = new Hash();
   // output errors and warnings
   var msgs = new Hash();
   // reload socket settings
   var doc = dv_svg.get_doc( PRJ.svg);
   var fp = find_FN( FILES, dv_board.cur_board_fname);
   if ( doc) dv_board.fill_socks_attrs( null, doc, fp.parsed);
   // if else - SVG just hidden :)
   for ( var i = 0; i < dv_board.cells.length; i++) {
     var e = dv_board.cells[i];
     if ( pbusy.contains( e.pcell)) continue;
     pbusy.push( e.pcell);
     if ( !( fp = find_FN( FILES, e.file))) continue;
     if ( typeof fp.parsed == 'undefined') continue;
     // check mates (up and down)
     fpP = fp.parsed;
     sock_limits.check_mates( fpP, e.pcell, msgs);
     var c1r = sock_limits.check_1( e.pcell, fpP, Bfp);
     for ( var mi = 0; mi < c1r.msg.length; mi++) dv_calc_cons.add( c1r.msg[ mi]);
     // power lines
     dv_board.power_summ( fp, fpP, powers, PRJ.parsed);
     // fillup parsed->sockets
     socks.set( e.pcell, fpP.name);
     // fillup parsed->BOM
     var tbom_n = 0;
     var tbom = bom.get( 'tibbit_' + fpP.name);
     if ( tbom != null) tbom_n = tbom;
     bom.set( 'tibbit_' + fpP.name, tbom_n + 1);
   }
   if ( typeOf( PRJ.parsed) == 'string' || typeOf( PRJ.parsed) == 'null') return;
   // options may temporary influe to power values
   fp = find_FN( FILES, dv_board.cur_board_fname);
   var fp_parsed_copy = Object.clone(fp.parsed);
   if ( typeOf( fp.parsed.ifa) != 'null') dv_board.ifa2br( fp.parsed.ifa, fp.parsed, fp_parsed_copy, PRJ.parsed.options, bom);
   // options may temporary influe to power values /
   PRJ.parsed.set( 'sockets', socks);
   PRJ.parsed.set( 'bom', bom);
   // board power lines itself
   fp = find_FN( FILES, dv_board.cur_board_fname);
   if ( !fp) {
     alert( 'Board file ' + dv_board.cur_board_fname + ' not found');
     return;  }
   if ( typeOf( fp.parsed.name) != 'null') {
     bom.set( 'board_' + fp.parsed.name, 1);
   }
   // summ board inputs
   // options may temporary influe to power values
//   dv_board.power_summ( fp, fp.parsed, powers, PRJ.parsed);
   dv_board.power_summ( fp, fp_parsed_copy, powers, PRJ.parsed);
   // options may temporary influe to power values /
   var tt = '';
   var t = '';
   t = 'p5v+';
   var pi = powers.get( t);
   if ( pi != 0) tt += t + ':' + pi + ' ';
   t = 'p5v-';
   var pi = powers.get( t);
   if ( pi != 0) tt += t + ':' + pi + ' ';
   t = 'pp15v+';
   var pi = powers.get( t);
   if ( pi != 0) tt += t + ':' + pi + ' ';
   t = 'pp15v-';
   var pi = powers.get( t);
   if ( pi != 0) tt += t + ':' + pi + ' ';
   t = 'pn15v+';
   var pi = powers.get( t);
   if ( pi != 0) tt += t + ':' + pi + ' ';
   t = 'pn15v-';
   var pi = powers.get( t);
   if ( pi != 0) tt += t + ':' + pi + ' ';
   // do not log for now
//   dv_calc_cons.add( tt);
    // now board may consume power by itself
//   if ( dv_board.cells.length > 0) {
     powers.set( 'p5v-state', dv_board.power_warn( powers, 'p5v', '+5V', msgs));
     powers.set( 'pp15v-state', dv_board.power_warn( powers, 'pp15v', '+15V', msgs));
     powers.set( 'pn15v-state', dv_board.power_warn( powers, 'pn15v', '-15V', msgs));
//   }
   PRJ.parsed.set( 'messages', msgs);
   dv_board.power_show( powers, 'p5v',   Vmeter0);
   dv_board.power_show( powers, 'pp15v', Vmeter1);
   dv_board.power_show( powers, 'pn15v', Vmeter2);
   var txt = dv_parse.txt( PRJ.parsed, {}, null);
   if ( txt != PRJ.file_text) {
     PRJ.set_text_plain( txt);
     PRJ.changed_in_mode = 1;
     PRJ.saved = false;
     set_modifyed( PRJ.file_text);
     var pn = pleasant_name( PRJ.file_name);
     change_project_wintitle( pn[ 0] + ': *' + pn[ 1]);
     menu_upd( PRJ);  }
   return;  },

 power_show: function( _powers, _k, _meter) {
   var tp = _k + '+';
   var tn = _k + '-';
   var ts = _k + '-state';
   var pip = _powers.get( tp);
   var pin = _powers.get( tn);
   var state = _powers.get( ts);
   var vals = { 'cons': pip, 'have': -pin };
   _meter.set_V( vals, state);
 },

 // small helper func
 r_set: function( _h, _id, _v) {
   if ( typeOf( _h.get(_id)) == 'null') _h.set(_id,new Array(_v));
   else _h.get(_id).push(_v);
 },

 power_warn: function( _powers, _k, _kstr, _r) {
   var t = '', te = '';
   var tp = _k + '+';
   var tn = _k + '-';
   pip = _powers.get( tp);  pin = _powers.get( tn);
   // if + (consumer) exist, but - (supplier) not - ERR
   if ( pip > 0 && pin == 0) {
     te = 'ERR';
     t = 'Your configuration lacks a ' + _kstr + ' power supply (the current consumption is ' + Math.abs( pip) + 'mA)';
     dv_calc_cons.add( 'ERROR! ' + t);  this.r_set(_r,te,t);
     return( 'E');  }
   // if + (consumer) exist, but - (supplier) not - ERR
   if ( pip == 0 && pin > 0) {
     return( 'O');  }
   // if more then 75% is consumed (pin is <0 always) - Err
   if ( pip > -pin) {
     te = 'ERR';
     t = 'Current consumption on the ' + _kstr + ' rail (' + Math.abs( pip) + 'mA) exceeds the available power capacity (' + Math.abs( pin) + 'mA)';
     dv_calc_cons.add( 'ERROR! ' + t);  this.r_set(_r,te,t);
     return( 'E');  }
   // if more then 50% is consumed (pin is <0 always) - Warn
   if ( pip > -pin/2) {
     te = 'WRN';
     t = 'Current consumption on the ' + _kstr + ' rail (' + Math.abs( pip) + 'mA) exceeds 50% of the available power capacity (' + Math.abs( pin) + 'mA)';
     dv_calc_cons.add( t);  this.r_set(_r,te,t);
     return( 'O');  }
   // if more then 50% is consumed (pin is <0 always) - Warn
   if ( pip == 0  && pin != 0) {
     te = 'INF';
     t = 'You do not need ' + _kstr + ' power sources and can remove them';
     dv_calc_cons.add( t);  this.r_set(_r,te,t);
     return( 'O');  }
 },

 power_summ: function( _fpm, _m, _powers, _g) {
   var xo = null, parall = 0;
   if ( typeOf( _g) != 'null' && typeOf( _g.options) != 'null') xo = _g.options;
   if ( xo && typeOf( xo.b_pparallel) != 'null') parall = parseInt( xo.b_pparallel);
   var t0 = 0, t1 = 0, tN = 0;
   // for board summ only if p5v_direct option == true
   var p5v_direct = true;
   if ( _fpm.type == 'B') p5v_direct = ( xo != null ? xo.p5v_direct : false);
   if ( typeof _m.p5v_dir != 'undefined' && p5v_direct) {
     dv_board.power_summ_hlp( _powers, _m.p5v_dir, 'p5v', parall);
   }
   if ( typeof _m.p5v != 'undefined') {
     dv_board.power_summ_hlp( _powers, _m.p5v, 'p5v', parall);
   }
   // for board summ only if pp15v_direct option == true
   var pp15v_direct = true;
   if ( _fpm.type == 'B') pp15v_direct = ( xo != null ? xo.pp15v_direct : false);
   if ( typeof _m.pp15v_dir != 'undefined' && pp15v_direct) {
     dv_board.power_summ_hlp( _powers, _m.pp15v_dir, 'pp15v', parall);
   }
   if ( typeof _m.pp15v != 'undefined') {
     dv_board.power_summ_hlp( _powers, _m.pp15v, 'pp15v', parall);
   }
   // for board summ only if pn15v_direct option == true
   var pn15v_direct = true;
   if ( _fpm.type == 'B' && xo != null) pn15v_direct = ( xo != null ? xo.pn15v_direct : false);
   if ( typeof _m.pn15v_dir != 'undefined' && pn15v_direct) {
     dv_board.power_summ_hlp( _powers, _m.pn15v, 'pn15v', parall);
   }
   if ( typeof _m.pn15v != 'undefined') {
     dv_board.power_summ_hlp( _powers, _m.pn15v, 'pn15v', parall);
   }
//console.log( _powers);
 },

 power_summ_hlp: function( _powers, _p_str, _p_lbl, _parall) {
   var t0 = 0, t1 = 0, tN = 0;
   tp = dv_board.power_str2val( _p_str);
   t = _p_lbl + ( tp[ 0] >= 0 ? '+' : '-');
   t_parall = _parall;
   t0 = _powers.get( t);
   if ( tp[ 1].substr( 0, 3) == 'int' || tp[ 0] > 0) t_parall = 0;
   if ( t_parall == 0 || ( t0 == 0 || tp[ 0] == 0)) tN = t0 + tp[ 0];
   else tN = ( Math.abs( t0) > Math.abs( tp[ 0]) ? tp[ 0] : t0);
   _powers.set( t, tN);
 },

 power_str2val: function( _s) {
   var f = parseFloat( _s);
   var ret = [ f, '' ];
   if ( typeOf( _s) == 'number') return( ret);
   var xa = _s.split( ' ');
   if ( xa.length > 1) {  ret[ 1] = xa[ 1].toLowerCase();  }
   return( ret);
 },

 // _ifa is socket->ifa (if then array)
 // _ss is an object with txt representation of default socket options
 // _opts - current project options
 ifa2br: function( _ifa, _br_init, _br, _opts, _bom) {
if ( typeOf( _opts) == 'null') return( false);
   var opts = _opts;		// for eval
   var board_init = _br_init;
   var board = _br;
   var bom = _bom;
   var did_some = false;
   for ( var i = 0; i < _ifa.length; i++) {
     if ( !eval( _ifa[ i][ 0])) continue;
     eval( _ifa[ i][ 1]);
     did_some = true;
   }
 return( did_some);
 },

});
