
var fileT = new Class({
 initialize: function( _type) {
   this.on_after_settxt = null;
   this.loaded = false;
   this.file_name = new String().concat();
   this.file_name = '';
   this.file_name_new = new String().concat();
   this.file_name_new = '';
   this.file_text = new String().concat();
   this.file_text = '';
   this.file_text_old = new String().concat();
   this.file_text_old = '';

   this.parsed = new String().concat();
   this.parsed = '';
   // svg obj
   this.svg = null;
   // type
   this.type = new String().concat();
   this.type = _type;
   this.got_from = 0;	// from server = 1, local = 2, pipe = 3
   this.changed_in_mode = -1;	// no change = -1, in text = 0, in graphics = 1, opts = 2
   this.saved = true;		// after change
   this.perms = new Hash({'r':true,'w':true});
   this.local_fs_pfx = '';	// for windows/pipe
 },
 from_ajax_c: function( _j) {
   this.loaded = true;
   this.set_text_plain( _j.plain);
   this.parsed = null;
   if ( typeof _j.parsed == 'undefined') this.parsed = dv_parse.ini( _j.plain, {});
   if ( this.parsed == null) this.parsed = dv_parse.ini( _j.plain, {});
 },
 from_ajax_noc: function( _fname, _ftype) {
   this.file_name = _fname;
   this.type = _ftype
 },

 // can fire a callback
 set_text_plain: function( _txt) {
   this.file_text = _txt;
   if ( this.on_after_settxt) this.on_after_settxt( this);
 }

});

function find_FN( _list, _fname) {
 var fn = '';
 for ( var i = 0; i < _list.length; i++) {
   var fn = _list[i].file_name;
   if ( fn == _fname) return( _list[i]);
   var fn = _list[i].file_name_new;
   if ( fn != '' && fn == _fname) return( _list[i]);
 }
 return( null); }

// _tid = tibbit id
function find_F_tid( _list, _tid) {
 var D;
 for ( var i = 0; i < _list.length; i++) {
   if ( _list[i].type != 'T') continue;
   if ( typeof _list[i].parsed == 'undefined') continue;
   D = _list[i].parsed;
   if ( typeof D.name == 'undefined') continue;
   if ( D.name == _tid) return( _list[i]);
 }
 return( null); }

function project_autosave( _C) {
 if ( !apply_FP_changes( Project)) {
   alert( 'This file cannot be saved as it contains syntax errors. Fix the errors or close the project (File->Close Project).');
   return;  }
 if ( Project.saved) {
   if ( _C == null) return;
   _C();
   return;  }
 if ( Project.got_from == files_pipe.itype) {
   set_modifyed( Project.file_text);
   if ( _C) _C();
   return;  }
 DL_save_YNC( Project, _C);  }

function drop_helper( _fname) {
 var f = find_FN( FILES, _fname);
 if ( !f) return;
 switch ( f.got_from) {
   case files_ajax.itype:	// server
     files_ajax.drop( _fname, drop_complete);
     break;
   case files_flesh.itype:	// local
     alert( 'Cannot delete file from the local file system. Please, disable it in menu for this file.');
     break;
   case files_pipe.itype:	// pipe
     alert( 'Can not drop PIPE stream in TIDE. Please, disable it in menu for this file.');
     break;
   default:
     alert( 'Unknown location '+f.got_from+' of ' + _fname);
     break;
 }
 return; }

function sync_FILES( _list_new, _list) {
 // if we have a new file - add it
 for ( var i = 0; i < _list_new.length; i++) {
   var fn = _list_new[i];
   var f = find_FN( _list, fn.file_name);
   // found
   if ( f != null) {
     // sync perms (may be updated)
     if ( typeof fn.perms != 'undefined') f.perms = fn.perms;
     continue;  }
   _list.push( fn);
 }
 // file is dropped - erase info
 for ( var i = 0; i < _list.length; i++) {
   if ( find_FN( _list_new, _list[i].file_name) != null) continue;
   // we can drop only from server - preserve others in a list
   if ( _list[i].got_from != files_ajax.itype) continue;
   _list.erase( _list[i]);
   i--;
 }
 sort_FILES( _list);
}

function sort_FILES_helper( _a, _b) {
// var a = _a.file_name.toLowerCase();
// var b = _b.file_name.toLowerCase();
 if ( _a.file_name > _b.file_name) return( 1);
 if ( _a.file_name < _b.file_name) return( -1);
 return( 0); }

function sort_FILES( _list) {  _list.sort( sort_FILES_helper);  }

// Live-search function for file list
function filterTable( term, table) {
 var terms = term.toLowerCase().split(" ");
 for ( var r = 0, m = table.rows.length; r < m; r++) {
    var display = '';
    // for each term do
    for ( var i = 0, j = terms.length; i < j; i++) {
      // strips all tags from row, then test if the
      // row Contains or not the appropriate filter term.
      if ( table.rows[r].innerHTML.replace(/<[^>]+>/g, "").toLowerCase().indexOf(terms[i]) < 0) {
	display = 'none';
      };
      table.rows[r].style.display = display;
    }
 }
}

// Populate the Open From Server dialog
function show_FILES( _win, _opts) {
 if ( !_win) {  alert( 'show_FILES nowhere?!');  return;  }
 var list = [];
 // This is the wrapper div used for the dialog contents
 var wrp = new Element( 'div');
 var searchForm = new Element( 'form', {  id:'top_small_form', });
 // Build up live-search form
 var searchBox = new Element( 'input', {
    name: 'livesearch',
    id: 'livesearch',
    type: 'text',
    size: '40',
    styles: { 'color':'#B2B2B2' },
    placeholder: 'Type here to filter the file list',
    events: {
      keyup: function( _e){
        new Event( _e).stop();
        var table = _win.getElementById( 'fileList');
        filterTable( this.get( 'value'), table);
        },
    },
 });
 searchForm.adopt( searchBox);
 if ( _opts.use_search) wrp.adopt( searchForm);

 var tbl = new Element( 'table', {
   id: 'fileList',
 });
 for ( var i = 0; i < FILES.length; i++) {
   var f = FILES[i];
   if ( _opts.got_from != null && _opts.got_from != f.got_from) continue;
   if ( _opts.types != null && !_opts.types.contains( f.type)) continue;
   var tr = new Element( 'tr', { id: f.file_name,
     events: {
       click: function( _e) {
         new Event( _e).stop();
         ed_clear( Project);
         ed_load_pre( this.id);
         if ( _opts.closewin) MochaUI.closeWindow( _win);
       },
     },
   });
   var tds = [];
   var href = '';
   var td = new Element( 'td', {
     html: '(' + f.type + ')&#160;',
   });
   if ( _opts.show_type) tds.push( td);
   var pln = pleasant_name( f.file_name);
   var td = new Element( 'td', {
     html: pln[ 0] + '&#160;&#160;&#160; <a>' + pln[ 1] + '</a>',
     'class': 'filename',
     styles: {  'white-space': 'nowrap', 'cursor':'pointer' },
   });
   tds.push( td);
   var td = new Element( 'td', {
     html: '(' + f.parsed.desc_short + ')' + ' ' + pln[ 2],
     styles: {  'cursor':'pointer' },
   });
   if ( _opts.show_desc) tds.push( td);
   var td = new Element( 'td', {
     html: '<a>' + f.got_from + '[x]</a>',
     styles: {  'cursor':'pointer' },
     events: {
       click: function( _) {
         new Event( _e).stop();
         drop_helper( this.parentNode.id);
         files_ajax.list( list_s);
         if ( _opts.closewin) MochaUI.closeWindow( _win);
       },
     },
   });
   if ( _opts.show_drop) tds.push( td);
   tr.adopt( tds);
   list.push( tr);
 }
 tbl.adopt( list);
 wrp.adopt( tbl);
 MUI.updateContent({ element: _win, content: wrp, });
 return;  }

function pleasant_name( _fname) {
 var ret = [ '', _fname, ''];
 var ta = new String( _fname).split( '/');
 if ( ta.length == 1) return( ret);
 switch ( ta[ 0]) {
   case 'P_pub': ret[0] = 'public';  ta.shift();  break;
   case 'P_pri': ret[0] = 'private';  ta.shift();
     if ( ta[ 0] == vars.user_user) ret[ 2] = '';
     else ret[ 2] = 'created by ' + ta[ 0];
     ta.shift();
     break;
   default:  break;
 }
 var x = new String().concat( ta);
 ret[ 1] = x;
 return( ret);  }
