
var dv_svg_interface = new new Class({
 initialize: function() {
   // nothing right now
   this.reasons = new Hash();
   this.tooltip_tout = null;
 },

 // used in SVG to get part (siffix size-based) of the module file name
 get_dev_ref_name: function( _form) {
   return( _form.toLowerCase());
 },

 find_in_devs: function( _doc, _id) {
   return( dv_svg.find_in_devs( _doc, _id));
 },

 get_child_by_id: function( _node, _id) {
   return( dv_svg.get_child_by_id( _node, _id));
 },

 register_in_storage: function( _id, _doc) {
  if ( _id == '') return;
  if ( typeof external == 'undefined') return;
  if ( typeof external.Context == 'undefined') return;
  if ( typeof external.Context.shared_docs == 'undefined') return;
  external.Context.shared_docs[ _id] = _doc;
 },

 // function used to construct SVG internal HREFs to objects
 // checks if definition is exist in <devs>. 
 // if yes - href is #type-size (local)
 // if not - href is "type/type-size.svg#type-size"
 // Chrome do not support external href - move all them to PCB svg (locally)
 get_tib_url: function( _doc, _form) {
   var r = '';
   var ref = this.get_dev_ref_name( _form);
   r = '#' + ref;
   if ( this.find_in_devs( _doc, ref)) return( r);
   // object not found in <devs>
   var fname = 'tibbits/' + ref  + '.svg';
   // try to find it's text and include into <devs> tree if possible
   var o = find_FN( SVGS, vars.svgs_path_pfx + fname);
   while ( o) {
     var devs = dv_svg.get_dom_section( _doc, 'devs');
     if ( !devs) break;
     // this created only to get DOM elements from text
//     var e = new Element('object').set( 'html', o.file_text);
     var e = dv_svg_interface.svg_from_str( _doc, o.file_text);
     if ( !e) {
       dv_cons.add( 'Internal SVG parser problem');
       break;  }
     var nn = e.getElementById( ref);
     if ( !nn) {
       dv_cons.add( 'SVG <span style=\'color:Red;\'>' + o.file_name + '</span> does not contain g id=\'' + ref + '\'');
       break;  }
     if ( typeof _doc.importNode != 'undefined') nn = _doc.importNode( nn, true);
     devs.appendChild( nn);
     return( r);  }
   // try to link object as external URL
   r = fname + '#' + ref;
   if ( Browser.chrome) alert( 'Warning for developers: ' + ref + ' not found in local storage');
   return( r);  },

 svg_from_str: function( _doc, _str) {
  var e = new Element('object').set( 'html', _str);
  var t = e.getElementById( 'Layer_1');
  if ( t && t.namespaceURI == 'http://www.w3.org/2000/svg') return( e);
  if ( typeof(DOMParser) == 'undefined') {
    alert( 'DOMParser is required for this old browser, but it is not supported in this browser version. Use modern browser.');
    return( null);  }
  var parser = new DOMParser();
  try {
    var xmlDoc = parser.parseFromString( _str, 'application/xml');
  } catch ( _e) {
   alert( 'DOMParser too weak in this browser version. Use modern browser.');
   return( null);  }
  return( xmlDoc);
 },

 devs2dom_clone: function( _doc, _form, _newid) {
   var devs = dv_svg.get_dom_section( _doc, 'devs');
   if ( !devs) return( null);
   var ref = this.get_dev_ref_name( _form);
   var dev = this.find_in_devs( _doc, ref);
   if ( !dev) return( dev);
   var clone = dev.cloneNode( true);
   if ( !clone) return( null);
   clone.setAttribute( "id", _newid);
   devs.appendChild( clone);
   return( clone);
 },

 // callbacks from SVG to notify after element actions
 on_add: function( _cellid, _file, _form, _angle) {
//dv_calc_cons.add( 'add to ' + _cellid + ' form:' + _form + ' angle:' + _angle);
   if ( !find_FN( FILES, _file)) {
     alert( 'on_add file \'' + _file + '\' not found. Bug');
     return;  }
   dv_board.cells_busy_XXX( _cellid, _file, _form, _angle, dv_board.xxx_del);
   dv_board.cells_busy_XXX( _cellid, _file, _form, _angle, dv_board.xxx_add);
   return;  },

 on_del: function( _cellid) {
//   dv_calc_cons.add( 'remove from:' + _cellid);
   dv_board.cells_busy_del_set( _cellid);
   for ( var i = 0; i < dv_board.cells.length; i++) {
     var e = dv_board.cells[i];
     dv_calc_cons.add( 'e (ondel): cell:' + e.cell + ' pcell:' + e.pcell + ' file: ' + e.file + ' form:' + e.form + ' angle:' + e.angle);
   }
   return;  },

 // what to do onclick for socket
 sock_click: function( _sid, _evt) {
   var items = [];
   // if socket is not empty
   if ( dv_board.cell_busy_with( _sid) != null) {
     items.push([ 'Place module', dv_svg_interface.show_tibbit_list_dialog]);
     items.push([ 'Delete', really_del]);
   } else {
//     items.push([ 'Place module', dv_svg_interface.show_tibbit_list_dialog]);
     dv_svg_interface.show_tibbit_list_dialog( _sid);
     return;
   }
   dv_cmenu.set_items( _sid, items);
   dv_cmenu.show( _sid, _evt.pageX, _evt.pageY + 50);
   return;
 },

 // what to do onclick for socket
 sock_tibbit_over_wrapped: function( _sid, _evt) {
   var tibbit = dv_board.cell_busy_with( _sid);
   if ( tibbit == null) return;
   // if socket is not empty
   var dev = find_FN( FILES, tibbit.file);
   if ( !dev) return;
   var html_txt = show_RD_tibbit_htmldata( dev);
   dv_cmenu.set_html( html_txt);
   var sz = Window.getSize();
   dv_cmenu.set_WxH( sz.x/3, '');
   dv_cmenu.show( _sid, _evt.pageX, _evt.pageY + 50);
   var D = dev.parsed;
   var Dgr = D.graphics;
   var svg_f = null;
   if ( typeof Dgr.svg != 'undefined') svg_f = Dgr.svg;
   if ( typeof Dgr.svg_preview != 'undefined') svg_f = Dgr.svg_preview;
   if ( svg_f == null) return;
   dv_svg.add( svg_f, '100%', '', $('dialog_details_svg'), { onload: tibbit_tooltip_onload, 'class': 'svg_tibbit_preview' });
   return;
 },

 sock_tibbit_over: function( _sid, _evt) {
   this.tooltip_tout = setTimeout( function() {
     dv_svg_interface.sock_tibbit_over_wrapped( _sid, _evt);
   }, 1000);
 },

 sock_tibbit_out: function( _sid, _evt) {
   if ( this.tooltip_tout) clearTimeout( this.tooltip_tout);
   this.tooltip_tout = null;
   dv_cmenu.hide();
 },

 // now it's not an actions, It's just tibbit list dialog
 show_tibbit_list_dialog: function( _sid) {
   MUI.tibbits_list_W( 'Choose tibbit to add', true);
   // allowed formfactors/devices and sizes
   var Bfp = find_FN( FILES, dv_board.cur_board_fname);
   var sockE = dv_board.get_sock( _sid);
   var E_limits = sock_limits.check_0_pre( sockE);
   var i = 0;
   var list = [];
   var list_inactive = [];
   var wrp = new Element( 'table', {
    id: 'DL_selectbox',
    'class': 'tibbit_list',
   });
   var wrp_inactive = new Element( 'table', {
    id: 'DL_selectbox',
    'class': 'tibbit_list',
   });
   dv_svg_interface.reasons.empty();
   var cell_busy = dv_board.cell_busy_with( _sid);
   var selected_value = null;
   if ( cell_busy) selected_value = cell_busy.file;
   for ( i = 0; i < FILES.length; i++) {
     var f = FILES[i];
     if ( f.type != 'T') continue;
     var D = f.parsed;
     var td_txt = '';
     var reg_d = new RegExp('^[0-9_]+$');
     td_txt += '<b>' + ( reg_d.test( D.name) ? '#' : '') + D.name.toUpperCase() + '</b>: ' + f.parsed.desc_short + '';
     var allowed = new Hash( '');
     var msgs = new Hash();
     allowed = sock_limits.check_mates( D, _sid, null);
     if ( allowed.ok) allowed = sock_limits.check_0( E_limits, _sid, D, Bfp);
     // check 'inactive' for non-admin
     if ( allowed.ok && typeOf( D.inactive) != 'null' && !vars.perms.admin) {
       allowed.ok = false;  allowed.msg = D.inactive;  }
     if ( !allowed.ok) dv_svg_interface.reasons.set( f.file_name, new String( allowed.msg).concat());
     // current active element - first if not defined
     if ( allowed.ok && selected_value == null) selected_value = f.file_name;
     var line_wrapper = new Element( 'tr', { });
     var line = new Element( 'td', {
       id: f.file_name,
       html: td_txt,
     });
     if ( !allowed.ok) line.addClass( 'tibbit_list_noactive');
     else line.addClass( 'tibbit_list_active');
     if ( allowed.ok) line.addEvent( 'dblclick', function( _e){
       new Event( _e).stop();
//       var deny_reason = dv_svg_interface.reasons.get( this.id);
//       if ( deny_reason !== null) return;
       var dev = find_FN( FILES, this.id);
       if ( dev == null) return;
       var d = dev.parsed;
       really_add( this.id, d.form, _sid);
       return;
     });
     line.addEvent( 'click', function( _e){
       new Event( _e).stop();
       var ttype = this.tagName;
       var cur_wrp = wrp;
       if ( !allowed.ok) cur_wrp = wrp_inactive;
       Array.each( wrp.getElements( ttype), function( _v, _k) {
         _v.removeClass( 'tibbit_list_current');
       });
       Array.each( wrp_inactive.getElements( ttype), function( _v, _k) {
         _v.removeClass( 'tibbit_list_current');
       });
       this.addClass( 'tibbit_list_current');
       show_RD_tibbit( this.id, _sid, $('right_details'));
     });
     line_wrapper.adopt( line);
     if ( allowed.ok) list.push( line_wrapper);
     else list_inactive.push( line_wrapper);
   }
   if ( selected_value == null) selected_value = list_inactive[ 0].getElement( 'td').id;
   wrp.adopt( list);
   wrp_inactive.adopt( list_inactive);
   var wrpwrp = new Element( 'div');
   wrpwrp.adopt( [ wrp, wrp_inactive]);
   MUI.updateContent({
    element:$('left_tibbits'),
    content: wrpwrp,
   });
//   wrp.focus();
//   wrp.set( 'value', selected_value);
   var se = null;
   if ( selected_value) se = $(selected_value);
   if ( se) se.addClass( 'tibbit_list_current');
   show_RD_tibbit( selected_value, _sid, $('right_details'));
   return;  },

 show_boards_list_dialog: function( _prjfp) {
   MUI.tibbits_list_W( 'Choose board to use', false);
   var i = 0;
   var list = [];
   var wrp = new Element( 'table', {
    id: 'DL_selectbox',
    'class': 'tibbit_list',
   });
   var selected_value = null;
   var D = _prjfp.parsed;
   var Db = null;
   if ( typeof D.base != 'undefined') Db = D.base;
   if ( Db && typeof Db.board != 'undefined') selected_value = Db.board;
   for ( i = 0; i < FILES.length; i++) {
     var f = FILES[i];
     if ( f.type != 'B') continue;
     var D = f.parsed;
     var td_txt = '';
     td_txt += f.parsed.description;
     // current active element - first if not defined
     if ( selected_value == null) selected_value = f.file_name;
     var line_wrapper = new Element( 'tr', { });
     var line = new Element( 'td', {
       id: f.file_name,
       html: td_txt,
     });
     line.setStyle( 'cursor', 'pointer');
     line.addEvent( 'dblclick', function( _e){
       new Event( _e).stop();
       really_use_board( this.id, _prjfp);
       return;
     });
     line.addEvent( 'click', function( _e){
       new Event( _e).stop();
       var ttype = this.tagName;
       Array.each( wrp.getElements( ttype), function( _v, _k) {
         _v.removeClass( 'tibbit_list_current');
       });
       this.addClass( 'tibbit_list_current');
       show_RD_board( this.id, _prjfp, $('right_details'));
     });
     line_wrapper.adopt( line);
     list.push( line_wrapper);
   }
   wrp.adopt( list);
   MUI.updateContent({
    element:$('left_tibbits'),
    content: wrp,
   });
   var se = null;
   if ( selected_value) se = $(selected_value);
   if ( se) se.addClass( 'tibbit_list_current');
   show_RD_board( selected_value, _prjfp, $('right_details'));
   return;  },

 get_labels_txt: function( _file) {
   var r = {};
   var fp = find_FN( FILES, _file);
   if ( !fp) return( r);
   if ( typeof fp.parsed == 'undefined') return( r);
   var D = fp.parsed;
   r["num"] = '#' + D.name.toUpperCase();
   var t = D.desc_short.toUpperCase();
   var t_a = D.desc_short.split( ' ');
   var idx = 0;
   var t_idx = null;
   r["desc_0"] = '';
   r["desc_1"] = '';
   r["desc_2"] = '';
   r["desc_3"] = '';
   if ( typeOf( D.desc_svg1) != 'null') r[ 'desc_0'] = D.desc_svg1;
   if ( typeOf( D.desc_svg2) != 'null') r[ 'desc_1'] = D.desc_svg2;
   if ( typeOf( D.desc_svg3) != 'null') r[ 'desc_2'] = D.desc_svg3;
   if ( typeOf( D.desc_svg4) != 'null') r[ 'desc_3'] = D.desc_svg4;
   if ( r[ 'desc_0'].length > 0) return( r);
   for ( var i = 0; i < t_a.length; i++) {
     t_idx = "desc_" + idx;
     r[t_idx] += t_a[i] + ' ';
     if ( r[t_idx].length > 15) idx++;
   }
   return( r);
 },
 set_labels: function( _el, _lbls) {
   var e = null;
   for ( var k in _lbls) {
     e = dv_svg.get_child_by_id( _el, 'LBL_' + k);
     if ( !e) continue;
     e.textContent = _lbls[k];
   }
 },
 get_colors_txt: function( _file) {
   var r = '';
   var fp = find_FN( FILES, _file);
   if ( !fp) return( r);
   if ( typeof fp.parsed == 'undefined') return( r);
   var D = fp.parsed;
   if ( typeof D.category == 'undefined') return( r);
   return( D.category);
 },
 set_colors: function( _el, _classfrom, _classto) {
   var els = dv_svg.get_child_by_class( _el, _classfrom);
   for ( var i = 0; i < els.length; i++) {
     els[i].setAttribute( 'class', _classto);
   }
 },

 // rotator and '+' '-' interface
 brd_rotate: function( _dir, _angle) {  dv_board.rotate( _dir);  },
 brd_chSz: function( _newsz) {  return( dv_board.chSzPc( _newsz, 1));  },
 
 open_opts_win_I: function() {  open_opts_win();  },
 
 // svg click
 svg2prj_option_upd: function( _oname, _val) {
   var o = 'opt_' + _oname;
   // if options tab is active
   if ( $(o)) $(o).set( 'value', _val);
   // update project options and recalc
   var pp = Project.parsed;
   if ( typeOf( pp.options) == 'null') pp.options = new Hash();
   Project.parsed.options.set( _oname, _val);
//console.log( 'at board:' + _oname + _val);
//console.log( Project.parsed.options);
   dv_board.on_change();
 },
 // options tab upd
 prj2svg_option_upd: function( _oname, _val) {
   var doc = dv_svg.get_doc( Project.svg);
   // if svg is active
   if ( doc) doc.rootElement.x_option_set( _oname, _val);
   // anyway, it will updated on svg onload
 },
 
 // rotator and '+' '-' interface
 tibbits_opacity_sw: function() {
   var val = dv_board.cur_modules_opacity;
   if ( val < 1) val = 1;
   else val = 0.1;
   dv_board.cur_modules_opacity = val;
   modules_opacity( val.toString());
   return( val);
 }

});
