
function place_all_modules() {
 if ( typeof Project.parsed == 'undefined') return;
 var D = Project.parsed;
 if ( typeof D.sockets == 'undefined') return;
 var Ds = D.sockets;
 var doc = dv_svg.get_doc( Project.svg);
 Ds.each(function( _v, _k){
   var f = find_F_tid( FILES, _v);
   if ( !f) return;
   var D = f.parsed;
   doc.rootElement.x_add_id( f.file_name, D.form, _k);
 });
 // create options to initialize them (new project - no options!)
 if ( typeOf( Project.parsed.options) == 'null') {
   var x = new Element( 'div');
   x.adopt( opts_show( Project));
   opts_fire_change( x);
   opts_apply_form( x, Project);
   x.destroy();
//   var txt = dv_parse.txt( Project.parsed, {}, null);
//   Project.set_text_plain( txt);
 }
 // create options to initialize them /
 dv_board.on_change();
}

function show_RD_tibbit_htmldata( _dev) {
 var t = '';
 var D = _dev.parsed;
 var Dgr = D.graphics;
 if ( Dgr.svg == null) {  alert( 'Device have no view');  return;  }
 var reg_d = new RegExp('^[0-9_]+$');
 t += '<h2>' + ( reg_d.test( D.name) ? '#' : '') + D.name.toUpperCase() + '</h2>';
 t += '<p>' + D.desc_short + '</p>';
 t += '<div id="dialog_details_svg"></div>';
 t += '<p>' + D.description + '</p>';
 t += '<table cellspacing="5" cellpadding="3" style="font-family:Arial;font-size:14px;color:white" width="100%" border="0">';
 if ( D.interrupt) t += html_AV_YON( 'Interrupt', D.interrupt);
 if ( D.serial) t += html_AV_YON( 'Serial', D.serial);
 if ( D.poe) t += html_AV_YON( 'PoE', D.poe);
 if ( D.p5v || D.pp15v || D.pn15v) {
   t += '<tr><td colspan="2" style="font-weight:bold">Power:</td></tr>';
 }
 if ( D.p5v) {
   var ta = D.p5v.split( ' ');
   var ta0 = parseFloat( ta[ 0]);
   t += html_AV_val( '+5V',  ( ta0 > 0 ? 'Consumes ' : ' Provides ') + Math.abs( ta0), 'prop_p5v', 'mA');  }
 if ( D.pp15v) {
   var ta = D.pp15v.split( ' ');
   var ta0 = parseFloat( ta[ 0]);
   t += html_AV_val( '+15V', ( ta0 > 0 ? 'Consumes ' : ' Provides ') + Math.abs( ta0), 'prop_pp15v', 'mA');  }
 if ( D.pn15v) {
   var ta = D.pn15v.split( ' ');
   var ta0 = parseFloat( ta[ 0]);
   t += html_AV_val( '-15V', ( ta0 > 0 ? 'Consumes ' : ' Provides ') + Math.abs( ta0), 'prop_pn15v', 'mA');  }
 t += '</table>';
 if ( D.desc_html) {
   var tmpfn = D.desc_html.replace( vars.devs_path_pfx, '');
   var fp_desc = find_FN( FILES, tmpfn);
   var xx = '';
   if ( fp_desc) xx = marked( fp_desc.file_text);
   else console.log( 'file '+tmpfn+ ' not found');
   t += '<br><div>' + xx + '</div>';
 }
 return( t);  }

function tibbit_tooltip_onload( _e) {
 dv_cmenu.move_to_fit();
}

function show_RD_tibbit( _file, _sid, _where) {
 var t = '';
 if ( !_where) return;
 MUI.updateContent({ element: _where, content: '', });
 var deny_reason = dv_svg_interface.reasons.get( _file);
 var dev = find_FN( FILES, _file);
 if ( dev == null) {  alert( 'Device description can not be loaded');  return;  }
 var D = dev.parsed;
 var Dgr = D.graphics;
 t += show_RD_tibbit_htmldata( dev);
 var t_b_cancel = DL_CM_Pb_gen_button( 'DL_btn_cancel', 'Cancel', 'float:left;padding:10px;');
 var t_b_choose = '';
 if ( deny_reason == null) {
   t_b_choose = DL_CM_Pb_gen_button( 'DL_btn_choose', 'Add Tibbit', 'float:right;padding:10px;');
 } else {
   t_b_choose = DL_CM_Pb_gen_errmsg( deny_reason);
 }
 var t_b = '<div class="bottom_button">' + t_b_cancel + t_b_choose + '</div>';
 MUI.updateContent({ element: _where, content: t, });
 MUI.updateContent({ element: $('DL_CM_Pb'), content: t_b, });
 $('DL_btn_cancel').removeEvents( 'click');
 $('DL_btn_cancel').addEvent( 'click', function( _e){
   new Event( _e).stop();
   MUI.closeWindow($('tibbits_list_W'));
 });
 if ( $('DL_btn_choose')) $('DL_btn_choose').removeEvents( 'click');
 if ( $('DL_selectbox')) $('DL_selectbox').removeEvents( 'keypress');
 if ( deny_reason == null) {
   $('DL_btn_choose').addEvent( 'click', function( _e){
     new Event( _e).stop();
     really_add( _file, D.form, _sid);
   });
   // if using select
   if ( $('DL_selectbox')) $('DL_selectbox').addEvent( 'keypress', function( _e){
     new Event( _e).stop();
     // on Enter key
     if ( _e.code != 13) return;
     if ( dv_svg_interface.reasons.get( this.value)) return;
     really_add( this.value, D.form, _sid);
   });
 }
 // show graphics
 var svg_f = null;
 if ( typeof Dgr.svg != 'undefined') svg_f = Dgr.svg;
 if ( typeof Dgr.svg_preview != 'undefined') svg_f = Dgr.svg_preview;
 if ( svg_f == null) return;
 // this one uses complex calculations
 var SVG = dv_svg.add( svg_f, '', '', $('dialog_details_svg'), { onload: tibbit_preview_onload, 'class': 'svg_tibbit_preview' });
 // this one is much simpler
// var mh = Math.floor( $('right_details').clientHeight * 0.6);
// var SVG = dv_svg.add( svg_f, '100%', mh, $('dialog_details_svg'), { onload: tibbit_preview_onload, 'class': 'svg_tibbit_preview' });
}

function tibbit_preview_onload( _e) {
 var SVGd = dv_svg.get_doc( this);
 if ( $('DL_selectbox')) {
   var lbls = dv_svg_interface.get_labels_txt( $('DL_selectbox').value);
   dv_svg_interface.set_labels( SVGd, lbls);
 }
 // to use complex calculations - uncomment this and above
// return;
 var w = $('right_details').clientWidth;
 var h = $('right_details').clientHeight;
 dv_svg.fit( this, 0.9, w, 0.7, h);
}

function html_AV_val( _name, _prop, _class, _sfx) {
 var t = '';
 t += '<tr>';
 t += '<td class="prop_hdr">' + _name + '</td>';
 t += '<td class="tibbit_prop ' + _class + '">' + _prop + _sfx + '</td>';
 t += '</tr>';
 return( t);  }

function html_AV_YON( _name, _prop) {
 var t = '';
 t += '<tr>';
 t += '<td class="prop_hdr">' + _name + '</td>';
 t += '<td class="tibbit_prop ' + html_class_YON( _prop) + '">' + _prop + '</td>';
 t += '</tr>';
 return( t);  }

function html_class_YON( _prop) {
 if ( typeof _prop == 'undefined') return( '');
 if ( _prop == null) return( '');
 var t = 'prop_' + _prop[0];
 return( t);  }

function show_RD_board( _file, _prjfp, _where) {
 var t = '';
 if ( !_where) return;
 MUI.updateContent({ element: _where, content: '', });
 var dev = find_FN( FILES, _file);
 if ( dev == null) {  alert( 'Device description can not be loaded');  return;  }
 var D = dev.parsed;
 var Dgr = D.graphics;
 if ( Dgr.svg == null) {  alert( 'Device have no view');  return;  }
 t += '<h2>' + D.desc_short + '</h2>';
 t += '<div id="dialog_details_svg"></div>';
 t += '<p>' + D.description + '</p>';
 var t_b_cancel = DL_CM_Pb_gen_button( 'DL_btn_cancel', 'Cancel', 'float:left;padding:10px;');
 var t_b_choose = DL_CM_Pb_gen_button( 'DL_btn_choose', 'Use this!', 'float:right;padding:10px;');
 var t_b = '<div class="bottom_button">' + t_b_cancel + t_b_choose + '</div>';
 MUI.updateContent({ element: _where, content: t, });
 MUI.updateContent({ element: $('DL_CM_Pb'), content: t_b, });
 $('DL_btn_cancel').removeEvents( 'click');
 $('DL_btn_cancel').addEvent( 'click', function( _e){
   new Event( _e).stop();
   MUI.closeWindow($('tibbits_list_W'));
 });
 $('DL_btn_choose').removeEvents( 'click');
 $('DL_btn_choose').addEvent( 'click', function( _e){
   new Event( _e).stop();
   really_use_board( _file, _prjfp);
 });
 // if using select
 if ( $('DL_selectbox')) $('DL_selectbox').removeEvents( 'keypress');
 if ( $('DL_selectbox')) $('DL_selectbox').addEvent( 'keypress', function( _e){
   new Event( _e).stop();
   // on Enter key
   if ( _e.code != 13) return;
   really_use_board( this.value, _prjfp);
 });
 // show graphics
 var svg_f = null;
 var img_f = null;
// if ( typeof Dgr.svg != 'undefined') svg_f = Dgr.svg;
 if ( typeof Dgr.svg_preview != 'undefined') svg_f = Dgr.svg_preview;
 if ( typeof Dgr.img_preview != 'undefined') img_f = Dgr.img_preview;
 if ( svg_f == null && img_f == null) return;
 if ( svg_f) dv_svg.add( svg_f, '100%', '300px', $('dialog_details_svg'), {});
 else ( new Element( 'img',{ 'src':img_f, 'width':'85%','height':'85%',styles:{display:'block',margin:'0 auto'}})).inject( $('right_details_pad'));
// else ( new Element( 'img',{ 'src':img_f, 'width':'100%', 'height':'100%'})).inject( $('right_details_pad'));
}

function DL_CM_Pb_gen_button( _id, _caption, _style) {
 var t = '';
 t += '<div class="button"';
 if ( _id != '') t += ' id="' + _id + '"';
 // update height
 _style += ';height:auto;';
 if ( _style != '') t += ' style="' + _style + '"';
 t += '><a>' + _caption + '</a></div>';
 return( t);  }

function DL_CM_Pb_gen_errmsg( _caption) {
 var t = '';
 t += '<span class="dlg_err" style="line-height:36px;vertical-align:middle"><img src="T_images/alert.png" id="DL_alerti_0"/>' + _caption + '</span>';
 return( t);  }

function set_board( _file, _prjfp) {
 var brd = new Hash();
 brd.set( 'board', _file);
 if ( typeof _prjfp.parsed == 'undefined') _prjfp.parsed = new Hash();
 if ( _prjfp.parsed == '') _prjfp.parsed = new Hash();
 if ( _prjfp.parsed.get( 'base') == null) _prjfp.parsed.set( 'base', brd);
}
function really_use_board( _file, _prjfp) {
 set_board( _file, _prjfp);
 if ( $('tibbits_list_W')) MUI.closeWindow($('tibbits_list_W'));
 update_editor_area( _prjfp);
 dv_board.on_change();
}
function really_add( _file, _form, _id) {
 var doc = dv_svg.get_doc( Project.svg);
 if ( dv_board.cell_busy_with( _id) != null) really_del_noonchange( _id);
// need: tibbit file, form-factor, element id
 doc.rootElement.x_add_id( _file, _form, _id);
 MUI.closeWindow($('tibbits_list_W'));
 dv_board.on_change();
}

function really_del( _id) {
 var obj = dv_board.cur_board;
 var doc = dv_svg.get_doc( obj);
 var devid = _id + '-attached';
 doc.rootElement.x_del_id( devid);
 dv_board.on_change();
}
function really_del_noonchange( _id) {
 var obj = dv_board.cur_board;
 var doc = dv_svg.get_doc( obj);
 var devid = _id + '-attached';
 doc.rootElement.x_del_id( devid);
}

// -------- many files load: group read and chained read
function load_grp_ini( _tolist) {
 dv_cons.add( 'Loading Tibbits, TPP definitions, etc...', true);
 var need_f_arr = [];
 for ( var i = 0; i < _tolist.length; i++) {
   var f = _tolist[i];
   need_f_arr.push( f.file_name);
 }
 if ( need_f_arr.length < 1) return;
 switch ( vars.mode) {
   case 20:
     files_pipe.read( vars.devs_path_pfx, need_f_arr, cb_read_ajax_ini);
     break;
   default:
     files_ajax.read( need_f_arr, cb_read_ajax_ini);
     break;
 }
}
function cb_read_ajax_ini( _j) {
 for ( var i = 0; i < _j.length; i++) {
   var f = _j[i];
   var F = find_FN( FILES, f.f_name);
   if ( !F) dv_cons.add( f.f_name + ' not found');
   else {  F.from_ajax_c( f);  F.file_text_old = f.plain;  }
 }
 dv_cons.add( 'DONE');
}

function load_svgs( _forfiles) {
 dv_cons.add( 'Loading images (SVGs)...');
 var need_f_arr = [];
 for ( var i = 0; i < _forfiles.length; i++) {
   var f = _forfiles[i];
   var X = f.parsed;
   if ( !X) continue;
   var Xgr = X.graphics;
   if ( !Xgr) continue;
   if ( typeof Xgr.svg == 'undefined') continue;
   if ( find_FN( SVGS, Xgr.svg)) continue;
   file = new fileT( 'I');
   file.file_name = Xgr.svg;
   SVGS.push( file);
   dv_cons.add( 'Loading ' + Xgr.svg + '...', true);
   load_svg_file( need_f_arr, file);
   if ( typeof Xgr.prj_preview_svg == 'undefined') continue;
   if ( find_FN( SVGS, Xgr.prj_preview_svg)) continue;
   file = new fileT( 'I');
   file.file_name = Xgr.prj_preview_svg;
   SVGS.push( file);
   dv_cons.add( 'Loading ' + Xgr.prj_preview_svg + '...', true);
   load_svg_file( need_f_arr, file);
 }
}

function load_svg_file( _need_arr, _fileT) {
 switch ( vars.mode) {
   case 20:
     var txt = files_pipe.read_txt( _fileT.file_name);
     if ( txt == '') dv_cons.add( 'Can not load file ' + _fileT.file_name);
     var F = find_FN( SVGS, _fileT.file_name);
     if ( F) F.set_text_plain( txt);
     break;
   default:
     _need_arr.push( _fileT.file_name);
     var R = new Request({
       url: _fileT.file_name,
       async: false,
       onFailure: files_ajax.hndl_E_const,
       onException: files_ajax.hndl_E_const,
       onSuccess: function( _ttxt, _rxml) {
         f = _need_arr.pop();
         dv_cons.add( 'done');
         var F = find_FN( SVGS, f);
         if ( F) F.set_text_plain( _ttxt);
       },
     });
     try {  R.get( _fileT.file_name);  } catch( _e) {
       dv_cons.add( '<span style="color:Red">' + _e.message + '</span> (first used in ' + _fileT.file_name + ')');
       SVGS.erase( _file);
     }
     break;
 } // switch /
}

function line_i2l( _n) {
 var ret = 'unknown';
 var n = _n;
 if ( typeOf( _n) == 'string') n = _n.toInt();
 switch( _n) {
   case 1:  ret = 'A';  break;
   case 2:  ret = 'B';  break;
   case 3:  ret = 'C';  break;
   case 4:  ret = 'D';  break;
   case 5:  ret = 'E';  break;
   case 6:  ret = 'F';  break;
   case 7:  ret = 'G';  break;
   case 8:  ret = 'H';  break;
 }
 return( ret);  }

function save_prj_preview() {
 // if not allowed to save project
 if ( !Project.perms.w) return;
 // need to be loaded from server
 if ( Project.got_from != files_ajax.itype) return;
 if ( typeOf( Project.parsed) == 'null') return;
 if ( typeOf( Project.parsed.base) == 'null') return;
 if ( typeOf( Project.parsed.base.board) == 'null') return;
 var brd_name = Project.parsed.base.board;
 var B = find_FN( FILES, brd_name);
 if ( !B) return;
 if ( typeOf( B.parsed) == 'null') return;
 if ( typeOf( B.parsed.graphics) == 'null') return;
 if ( typeOf( B.parsed.graphics.prj_preview_svg) == 'null') return;
 var svg_name = B.parsed.graphics.prj_preview_svg;
 var S = find_FN( SVGS, svg_name);
 if ( !S) return;
 if ( typeOf( S.file_text) == 'null') return;

 var e = new Element( 'div', {
   id: 'tmp_svg_div',
   styles: {
     'width':'150px', 'height':'150px',
     'position':'absolute', 'z-index':'10000',
     'top':'-1000px', 'left':'-1000px'
   }
 });
 document.body.grab( e);
 var opts = { id: 'SVG_prj_preview' };
 dv_prj_preview.after_gen = function( _doc) {
   var s = new XMLSerializer();
   data = s.serializeToString( _doc);
   if ( $('SVG_prj_preview')) $('SVG_prj_preview').destroy();
   e.destroy();
   if ( typeOf( $('tmp_svg_div')) != 'null') $('tmp_svg_div').destroy();
   var b = Browser;
   if ( Browser.ie9 || b.chrome46) {	// suxx. chrome46 is IE10/Edge!
     x = '<?xml version="1.0" encoding="UTF-8"?>\n';
     x += '<?xml-stylesheet href="pcb-simple.css" type="text/css" ?>\n';
     data = x + data;  }
   var R = new Request.JSON({ url:vars.io_ajax_url, async:true,
     noCache:true, method:'post',
     onError: function( _txt, _err){  console.log( _txt);  },
     onFailure: function( _xhr){  console.log( _xhr);  },
     onException: function( _e, _v){  console.log( _v);  },
   });
   var fn = Project.file_name;
   var o = {'func':'save_gfx','file':fn,'type':'svg','data':data};
   o = files_ajax.add_user( o);
   R.post( o);
 };
 opts.onload = dv_prj_preview.gen;
 dv_svg.add( S.file_name, '', '', e, opts);
}

function modules_opacity(_val) {
 var doc = dv_svg.get_doc( Project.svg);
 if ( !doc) return;
 for ( var i = 0; i < dv_board.cells.length; i++) {
   var c = dv_board.cells[i];
   var ten = c.pcell + '-attached';
   var e = dv_svg_interface.get_child_by_id( doc.rootElement, ten);
   e.setAttribute('opacity',_val);
 }
}
