var files_pipe = {
 // itype is integer interface type
 initialize: function( _itype) {
   this.itype = _itype;
   this.hndl_S = function() {};
   this.FileMgr = null;
   if ( typeof external != 'undefined' && external != null &&
        typeof external.FileMgr != 'undefined') {
     this.FileMgr = external.FileMgr;
   }
 },

 list_helper: function( _fhsh, _pfx, _subdir, _type) {
   if ( !files_pipe.FileMgr) return;
   var pfx_d = _pfx + _subdir;
   files_pipe.FileMgr.BaseDir = vars.win_main_pfx + pfx_d;
   var fn = files_pipe.FileMgr.FindFirstFileName("*.*");
   while ( fn != '') {
     var ta = new Hash();
     var fname = ( _subdir != '' ? _subdir + '\\' : '') + fn;
     var fn = files_pipe.win2unix( fname);
     ta.set( 'f_type', _type);
     ta.set( 'local_fs_pfx', _pfx);
     _fhsh.set( fn, ta);
//dv_cons.add( 'fff0:' + fn + ' fff1:' + _pfx + _subdir + '\\' + fn);
     fn = files_pipe.FileMgr.FindNextFileName();
   }
 },

 list: function( _cb) {
   this.hndl_S = _cb; 
   var files = new Hash();
   files.set( 'files', new Hash());
   // using devs_pfx here only. all other funcs need it in _fname
   var pfx = vars.devs_path_pfx;
   files_pipe.list_helper( files.files, pfx, '', 'P');
   files_pipe.list_helper( files.files, pfx, 'boards', 'B');
   files_pipe.list_helper( files.files, pfx, 'tibbits', 'T');
   files_pipe.list_helper( files.files, pfx, 'tibbits-desc', 'T-d');
   this.hndl_S( files);
 },

 read_txt: function( _fname) {
   var r = '';
   if ( !files_pipe.FileMgr) return( null);
   files_pipe.FileMgr.BaseDir = vars.win_main_pfx;
   var fn = files_pipe.unix2win( _fname);
//dv_cons.add( 'reading ' + _fname, true);
   try {
   r = files_pipe.FileMgr.ReadTextFile( fn);
   } catch (_e) {  dv_cons.add( 'Read ' + _fname + ' error:' + _e.message);  }
//dv_cons.add( ' :' + ( r == '' ? 'null': 'non-null'));
   return( r);
 },

 // pfx - prefix for all files
 read: function( _pfx, _fname, _cb) {
   this.hndl_S = _cb; 
   if ( typeOf( _fname) == 'null') return( null);
   var xa = [];
   if ( typeOf( _fname) == 'string') {
     var txt = files_pipe.read_txt( _pfx + _fname);
     var x = new Hash({'f_name':_fname,'plain':txt});
     xa.push( x);  }
   if ( typeOf( _fname) == 'array') {
     for ( var i = 0; i < _fname.length; i++) {
       var fn = _fname[i];
       var txt = files_pipe.read_txt( _pfx + fn);
       var x = new Hash({'f_name':fn,'plain':txt});
       xa.push( x);  }
   }
   this.hndl_S( xa);
 },

 write: function( _fname, _cont) {
   // FIX: array handling ?
   if ( !files_pipe.FileMgr) return;
   files_pipe.FileMgr.BaseDir = vars.win_main_pfx;
   var fn = files_pipe.unix2win( _fname);
//dv_cons.add( 'writing ' + _fname, true);
   try {
   files_pipe.FileMgr.WriteTextFile( fn, _cont);
   } catch (_e) {  dv_cons.add( 'Write ' + _fname + ' error:' + _e.message);  }
 },

 drop: function( _fname) {
   if ( !files_pipe.FileMgr) return;
   files_pipe.FileMgr.BaseDir = vars.win_main_pfx;
   alert('drop for local?! check for bug');
 },

 // unix to win
 unix2win: function( _fname) {
   var xx = _fname.replace(/\//g,'\\');
   return( xx);
 },
 win2unix: function( _fname) {
   var xx = _fname.replace(/\\/g,'\/');
   return( xx);
 }

};