var dv_parse = new new Class({
 initialize: function() {
  // nothing
 },

 ini: function( _s, _opts) {
   var lines = splitL( _s);

   function splitL( _s) {  return( _s.replace(/\r\n/g,'\n').split(/\n/));  }

   var t = '';
   var root_a = new Hash();
   var curr_a = root_a;
   var err_cnt = 0;
   var i = -1;
   Array.each (lines, function(line) {
     var match;
     i++;
//console.log( line);
     // one-way preprocessor inside, like: #if (eval) then property<op>value
     if ( line.substring( 0, 3) == '#if') {
       line = line.replace(/\#if\s*/g,'');
       var x = line.split(/ then /);
       if ( x.length < 2) return( null);
       if ( typeOf( curr_a.ifa) == 'null') curr_a.set( 'ifa', new Array());
       curr_a.ifa.push( x);  }
     line = line.replace(/\[\]\s*=/g,' =');
     line = line.replace(/=\s*\"/g,'= ').replace(/\"\s*$/g,'');
     line = line.replace(/\"/g,'');
// disabled for [options]
//     line = line.replace(/;.*/g,'');
     if (/~\s*(;.*)?$/.test(line)) return( null);
     else if ( match = line.match(/^\[(.*)\]$/)) {
       ta = new Hash();  curr_a = ta;
       root_a.include(match[1],ta);  }
     else if ( match = line.match(/^([\w\[\]]+)\s*=\s*(.*)\s*$/)) {
       var tmpv = curr_a.get(match[1]);
       if ( tmpv !== null) {
         if ( typeof tmpv != 'object') tmpv = new Array( tmpv);
         tmpv.push( match[2]);  curr_a.set(match[1],tmpv);
       } else {
         if ( match[2] === 'false') match[2] = false;
         if ( match[2] === 'true') match[2] = true;
         curr_a.include(match[1],match[2]);
       }
     }
     else if ( line == '') ;
     else {
      err_cnt++;
      if ( _opts.err_line) _opts.err_line( 'Line #' + i + ' \'' + line + '\' is invalid');
      if ( _opts.err_stop) return( null);
     }
   });
   if ( err_cnt < 1) return( root_a);
   if ( _opts.errs) _opts.errs( 'File contains ' + err_cnt + ' errors');
   if ( _opts.verify) return( null);
   return( root_a); 
 },

 txt: function( _obj, _opts, _pfx) {
   var ret = '';
   switch ( typeOf( _obj)) {
     case 'array':
       for ( var i = 0; i < _obj.length; i++) {
         ret += _pfx;
         if ( typeOf( _pfx) != 'null') ret += '\"';
         ret += _obj[i];
         if ( typeOf( _pfx) != 'null') ret += '\"';
         ret += '\n';
       }
       break;
     case 'hash':
       var ka = _obj.getKeys();
       // first walk all strings and base types
       for ( var i = 0; i < ka.length; i++) {
         var k = ka[i];  var v = _obj.get(k);
         if ( typeOf( v) != 'string' && typeOf( v) != 'number' &&
              typeOf( v) != 'boolean' && typeOf( v) != 'date') continue;
         ret += '' + k + ' = ';
         if ( typeOf( v) == 'string') ret += '\"';
         ret += v;
         if ( typeOf( v) == 'string') ret += '\"';
         if ( ret != '') ret += '\n';
       }
       // then all other objects
       for ( var i = 0; i < ka.length; i++) {
         var k = ka[i];  var v = _obj.get(k);
         if ( typeOf( v) == 'string') continue;
         if ( typeOf( v) == 'number') continue;
         if ( typeOf( v) == 'boolean') continue;
         if ( typeOf( v) == 'date') continue;
         var vv = dv_parse.txt( v, _opts, k + '[]=');
         if ( vv != '') {
           if ( typeOf( _pfx) == 'null') ret += '\n[' + k + ']\n' + vv + '';
           else ret += '' + vv + '';
         }
       }
       break;
     default:  break;
   }
   return( ret);
 },

 get_bool: function( _v, _def) {
   if ( typeof _v == 'undefined') return( _def);
   if ( _v == null) return( _def);
   if ( typeof _v == 'boolean') return( _v);
   if ( _v == 0) return( false);
   if ( typeof _v != 'string') alert( 'not a string:' + _v);
   if ( _v.length < 1) return( false);
   var t = _v.toLowerCase();
   if ( t == 'false') return( false);
   if ( t[0] == 'n') return( false);
   return( true);
 },
 get_YNO: function( _v, _def) {
   if ( typeof _v == 'undefined') return( _def);
   if ( _v == null) return( _def);
   if ( _v.length < 1) return( _def);
   if ( _v[0] == 'N' || _v[0] == 'n') return( 'N');
   if ( _v[0] == 'Y' || _v[0] == 'y') return( 'Y');
   if ( _v[0] == 'O' || _v[0] == 'o') return( 'O');
   return( _def);
 },

 parse_option: function( _s) {
   var ret = new Hash();
   var oa = _s.split(/;/);
   for ( var i = 0; i < oa.length; i++) {
     var nosp = oa[i].replace(/^\s*/g,'').replace(/\s$/g,'');
     var av = nosp.split(/=/);
     if ( i != 0 && av.length < 2) continue;
     if ( i == 0 && av.length < 1) continue;
     if ( i == 0) {  ret.set( 'I', av[0]);  continue;  }
     if ( av[0] == 'S') {
       var aa = dv_parse.parse_option_S( nosp.replace(/^S=/g,''));
       ret.set( av[ 0], aa);
       continue;  }
     ret.set( av[ 0], av[ 1]);
   }
   return( ret);
 },
 parse_option_option: function( _s) {
   var reta = [];
   var ret = null;
   var oa = _s.split(/\//);
   for ( var i = 0; i < oa.length; i += 2) {
     if ( i+1 > oa.length) continue;
     var v = oa[i].replace(/^\s*/g,'').replace(/\s$/g,'');
     if ( typeOf( oa[(i+1)]) == 'null') {
       console.log( 'Possible syntax error (unterminated) at:' + _s);
       return( reta);
     }
     var k = oa[(i+1)].replace(/^\s*/g,'').replace(/\s$/g,'');
     ret = new Hash();
     ret.set('k',k);
     ret.set('v',v);
     reta.push( ret);
   }
   return( reta);
 },
 parse_option_S: function( _s) {
   var oa = _s.split(/\?/);
   var oa_dep = oa[0].split(/,/);
   var oa_if = oa[1];
   var oa_else = null;
   var x = oa[2].split(/:/);
   var oa_then = x[0];
   if ( x.length > 1) oa_else = x[1];
   var ret = new Hash({'dep':oa_dep,'if':oa_if,'then':oa_then,'else':oa_else});
   return( ret);
 }

});
