var rules0 = new Class({
   initialize: function() {
     this.list_a = [];
     this.list_d = [];
     this.seqs_a = [];		// rules sequence
     this.any = true;
   }
});
var rules1 = new Class({
   initialize: function() {
     this.list_a = [];
     this.list_d = [];
     this.seqs_a = [];		// rules sequence
     this.any = false;
   }
});

var sock_limits = new new Class({
 initialize: function( _ehndl) {
    this.uid = 0;
 },

 // parse rules like "+ALL -dev" and creates two lists: allow and deny
 parse_accepts: function( _accepts, _rules) {
   _accepts = _accepts.toLowerCase();
//console.log( _accepts);
   _rules.list_a = [];  _rules.list_d = [];
   _rules.seqs_a = [];
   if ( typeof _accepts == 'undefined') return( true);
   if ( _accepts == '') return( true);
   if ( _accepts == '+all') {  _rules.any = true;  return( true);  }
   if ( _accepts == '-all') {  _rules.any = false;  return( true);  }
   accepts = _accepts.split( ' ');
   _rules.any = true;
//   if ( accepts == 'undefined') return( true);
   for ( var i = 0; i < accepts.length; i++) {
     var a = accepts[i];
//console.log( a);
     var a_c = a[0];
     var a_r = a.substring( 1);
     if ( a_c == '-' && a_r == 'all') {  _rules.any = false;  continue;  }
     if ( a_r == 'all') continue;
     var s = { 's':a_c,'r':a_r };
     _rules.seqs_a.push( s);
     var to = _rules.list_a;
     if ( a_c == '-') to = _rules.list_d;
     to.push( a_r);
   }
//console.log( _rules);
 },

 // _ifa is socket->ifa (if then array)
 // _ss is an object with txt representation of default socket options
 // _opts - current project options
 ifa2ss: function( _ifa, _ss, _opts) {
   var opts = _opts;		// for eval
   var sock = _ss;
   var did_some = false;
   for ( var i = 0; i < _ifa.length; i++) {
//console.log( _ifa[ i][ 0] + ' : ' + _ifa[ i][ 1]);
     if ( !eval( _ifa[ i][ 0])) continue;
     eval( _ifa[ i][ 1]);
     did_some = true;
   }
 return( did_some);
 },
 // same for module
 ifa2m: function( _ifa, _m, _br, _opts) {
   var opts = _opts;		// for eval
   var m = _m;
   var board = _br;
   var opts = _opts;
   var did_some = false;
   for ( var i = 0; i < _ifa.length; i++) {
//console.log( _ifa[ i][ 0] + ' : ' + _ifa[ i][ 1]);
     if ( !eval( _ifa[ i][ 0])) continue;
     eval( _ifa[ i][ 1]);
     did_some = true;
   }
 return( did_some);
 },

 check_0_pre: function( _sockE) {
   var ret = new Hash();
   var tib_accepts = dv_svg.getA( _sockE, 'tib_accepts', '+all');
   ret.set( 'tib_accepts', tib_accepts);
   var accept_rules = new rules0();
   sock_limits.parse_accepts( tib_accepts, accept_rules);
   ret.set( 'accept_rules', accept_rules);

   var tib_features = dv_svg.getA( _sockE, 'tib_features', '-all');
   ret.set( 'tib_features', tib_features);
   var feature_rules = new rules1();
   sock_limits.parse_accepts( tib_features, feature_rules);
   ret.set( 'feature_rules', feature_rules);
//console.log( tib_features);
//console.log( feature_rules);

   var tib_lines = dv_svg.getA( _sockE, 'tib_lines', 'Y Y Y Y');
   ret.set( 'tib_lines', tib_lines);
   var tib_serial = dv_svg.getA( _sockE, 'tib_serial', 'N');
   ret.set( 'tib_serial', tib_serial);
   var tib_interrupt = dv_svg.getA( _sockE, 'tib_interrupt', 'N');
   ret.set( 'tib_interrupt', tib_interrupt);
   var tib_poe = dv_svg.getA( _sockE, 'tib_poe', 'N');
   ret.set( 'tib_poe', tib_poe);
   return( ret);
 },
 // called for tibbits dialog
 // _b - board object (from FILES)
 check_0: function( _limits, _sid, _m, _b) {
   var ret = new Hash();
   var ok = true;
   var msg = '';
   var m = Object.clone( _m);
   if ( typeOf( _m.ifa) != 'null') sock_limits.ifa2m( _m.ifa, m, _b.parsed, Project.parsed.options);
   if ( ok) {
     ok = sock_limits.check_accepts( _limits.accept_rules, m);
     if ( !ok) msg = 'The target socket cannot accommodate this Tibbit';
   }
   if ( ok) {
//console.log(_limits.feature_rules);
     ok = sock_limits.check_features( _limits.feature_rules, m);
     if ( !ok) msg = 'The target socket has no features('+m.req_feature+') to accommodate this Tibbit';
   }
   if ( ok) {
     var exti = new Hash();
     // new: module may take several sockets - check all the lines
     var doc = dv_svg.get_doc( dv_board.cur_board);
     if ( doc == null) return( true);
     var angle = doc.rootElement.x_get_angle( _sid);
     var needs = sock_limits.form_needs( m.form, angle);
     var xy = sock_limits.get_phy_pos( _sid);
     var plus_L = ( needs.get( 'L') ? needs.get( 'L') : 0);
     var plus_R = ( needs.get( 'R') ? needs.get( 'R') : 0);
     if ( plus_L > 0 && plus_R > 0) {
       alert( 'Error: Tibbit occupies more sockets on the left AND on the right.');
       return( ret);  }
     // check all places module may take (from left to right)
     var ii = 0;
     var ll = '';
     if ( angle == 270) {  var x = plus_L;  plus_L = plus_R;  plus_R = x;  }
     for ( var i = plus_R; i <= plus_L; i++) {
        var c = sock_limits.get_phy_xy( xy.get( 'x') + ( angle == 270 ? i : -i), xy.get( 'y'));
        if ( typeOf( c) != 'string') continue;
        if ( c[ 0] != 's') continue;
//        if ( c == _sid) continue;	// ignore current one
        e = dv_board.get_sock( c);
        var lines = dv_svg.getA( e, 'tib_lines', 'Y Y Y Y');
        ll += lines + ' ';
        var msgs = new Hash();
        ok = sock_limits.check_lines( ll, m, ( ii * 4), ( ii * 4) + 4, exti, msgs);
        if ( !ok) {
          msg = 'The target socket ' + c.toUpperCase() + ' does not provide control line';
          var lks = exti.getKeys();
          if ( lks.length > 1) msg += 's';
          msg += ' ';
          for ( var l = 0; l < lks.length; l++) {
            if ( l > 0) msg += ',';
            msg += line_i2l( ( lks[ l].toInt() - ii*4));  }
          msg += ' (OR do you need to move a jumper?)';
          break;  }
        ii++;
     }
     // new: module may take several sockets - check all the lines /
   }
   if ( ok) {
     ok = sock_limits.check_serial( _limits.tib_serial, m);
     if ( !ok) msg = 'The target socket does not provide UART lines (OR do you need to move a jumper?)';
   }
   if ( ok) {
     ok = sock_limits.check_interrupt( _limits.tib_interrupt, m);
//console.log( _limits.tib_interrupt);
     if ( !ok) msg = 'The target socket does not provide an interrupt line (OR do you need to move a jumper?)';
   }
   if ( ok) {
     ok = sock_limits.check_poe( _limits.tib_poe, m);
     if ( !ok) msg = 'The target socket does not provide PoE lines (OR do you need to move a jumper?)';
   }
   if ( ok) {
     ok = sock_limits.check_module_border( _sid, m);
     if ( !ok) msg = 'BUG: this Tibbit does not fit within socket borders (tell Tibbo about this message)';
   }
   ret.set( 'ok', ok);
   ret.set( 'msg', msg);
   return( ret);
 },
 // called on update
 // _b - board (from FILES)
 check_1: function( _sid, _m, _b) {
   var ret = new Hash();
   var ok = true;
   var msg = [];
   var m = Object.clone( _m);
   if ( typeOf( _m.ifa) != 'null') sock_limits.ifa2m( _m.ifa, m, _b.parsed, Project.parsed.options);
   //
   var doc = dv_svg.get_doc( dv_board.cur_board);
   if ( doc == null) return( {'ok':true,'msg':[]});
   var xy = sock_limits.get_phy_pos( _sid);
   var _sockE = dv_board.get_sock( _sid);
   if ( typeOf( _sockE) == 'null') return({'ok':true,'msg':[]});
   var tib_accepts = dv_svg.getA( _sockE, 'tib_accepts', '+all');
   var accept_rules = new rules0();
   sock_limits.parse_accepts( tib_accepts, accept_rules);
   var tib_features = dv_svg.getA( _sockE, 'tib_features', '-all');
   var feature_rules = new rules1();
   sock_limits.parse_accepts( tib_features, feature_rules);
   var tib_serial = dv_svg.getA( _sockE, 'tib_serial', 'N');
   var tib_interrupt = dv_svg.getA( _sockE, 'tib_interrupt', 'N');
   var tib_poe = dv_svg.getA( _sockE, 'tib_poe', 'N');
   // /
   if ( ok) {
     ok = sock_limits.check_accepts( accept_rules, m);
     if ( !ok) msg.push( 'Socket ' + _sid.toUpperCase() + ' cannot accommodate Tibbit #' + m.name);
   }
   if ( ok) {
     ok = sock_limits.check_features( feature_rules, m);
     if ( !ok) msg.push( 'Socket ' + _sid.toUpperCase() + ' cannot accommodate Tibbit #' + m.name + ' because of required feature ' + m.req_feature);
   }
   if ( ok) {
     var exti = new Hash();
     // new: module may take several sockets - check all the lines
     var doc = dv_svg.get_doc( dv_board.cur_board);
     if ( doc == null) return( true);
     var angle = doc.rootElement.x_get_angle( _sid);
     var needs = sock_limits.form_needs( m.form, angle);
     var xy = sock_limits.get_phy_pos( _sid);
     var plus_L = ( needs.get( 'L') ? needs.get( 'L') : 0);
     var plus_R = ( needs.get( 'R') ? needs.get( 'R') : 0);
     if ( plus_L > 0 && plus_R > 0) {
       alert( 'Error: Tibbit occupies more sockets on the left AND on the right.');
       return( ret);  }
     // check all places module may take (from left to right)
     var ii = 0;
     var ll = '';
     if ( angle == 270) {  var x = plus_L;  plus_L = plus_R;  plus_R = x;  }
     for ( var i = plus_R; i <= plus_L; i++) {
        var c = sock_limits.get_phy_xy( xy.get( 'x') + ( angle == 270 ? i : -i), xy.get( 'y'));
//console.log( 'check' + c + ' ' + i);
        if ( typeOf( c) != 'string') continue;
        if ( c[ 0] != 's') continue;
//        if ( c == _sid) continue;	// ignore current one
        e = dv_board.get_sock( c);
        var lines = dv_svg.getA( e, 'tib_lines', 'Y Y Y Y');
        ll += lines + ' ';
        var msgs = new Hash();
        ok = sock_limits.check_lines( ll, m, ( ii * 4), ( ii * 4) + 4, exti, msgs);
        if ( !ok) {
          var t = 'Socket ' + c.toUpperCase() + ' does not provide control line';
          var lks = exti.getKeys();
          if ( lks.length > 1) t += 's';
          t += ' ';
          for ( var l = 0; l < lks.length; l++) {
            if ( l > 0) t += ',';
            t += line_i2l( ( lks[ l].toInt() - ii*4));  }
          t += ', which is/are required by Tibbit ' + m.name + ' residing in this socket';
          msg.push( t);
          break;  }
        var ks = msgs.getKeys();
        for ( var ik = 0; ik < ks.length; ik++) {
          msg.push( 'Socket ' + c.toUpperCase() + ' does not provide control line ' + line_i2l( ( ks[ ik].toInt() - ii*4)) + ' ==&gt; ' + msgs.get( ks[ ik]));
        }
        ii++;
     }
     // new: module may take several sockets - check all the lines /
   }
   if ( ok) {
     ok = sock_limits.check_serial( tib_serial, m);
     if ( !ok) msg.push( 'Socket ' + _sid.toUpperCase() + ' does not provide UART lines, which are required by Tibbit #' + m.name + ' residing in this socket (OR do you need to move a jumper?)');
   }
   if ( ok) {
     ok = sock_limits.check_interrupt( tib_interrupt, m);
     if ( !ok) msg.push( 'Socket ' + _sid.toUpperCase() + ' does not provide an interrupt line, which is required by Tibbit #' + m.name + ' residing in this socket (OR do you need to move a jumper?)');
   }
   if ( ok) {
     ok = sock_limits.check_poe( tib_poe, m);
     if ( !ok) msg.push( 'Socket ' + _sid.toUpperCase() + ' does not provide PoE lines, which are required by Tibbit #' + m.name + ' residing in this socket (OR do you need to move a jumper?)');
   }
   if ( ok) {
     ok = sock_limits.check_module_border( _sid, m);
     if ( !ok) msg.push( 'Module does not fit socket borders');
   }
   ret.set( 'ok', ok);
   ret.set( 'msg', msg);
   return( ret);
 },

 // _m = module parsed description object
 check_accepts: function( _rules, _m) {
   var r_a = [];
   var r_d = [];
   var v = '';
   if ( typeof _m.name == 'undefined') {
     alert( 'Module ' + _m.name + ' have no name definition');
     return( false);  }
   if ( typeof _m.form == 'undefined') {
     alert( 'Module ' + _m.name + ' have no form definition');
     return( false);  }
   // check for acceptable form-factor
   v = _m.form.toLowerCase();
   var ret = _rules.any;
//console.log( 'ret0 ' + v + ':' + ret);
   for ( var i = 0; i < _rules.seqs_a.length; i++) {
      var cr = _rules.seqs_a[i];
      if ( v == cr.r) ret = ( cr.s == '-' ? false : true);
   }
//console.log( 'ret1 ' + v + ':' + ret);
   v = _m.name.toLowerCase();
   for ( var i = 0; i < _rules.seqs_a.length; i++) {
      var cr = _rules.seqs_a[i];
      if ( v == cr.r) ret = ( cr.s == '-' ? false : true);
   }
//console.log( 'ret2 ' + v + ':' + ret);
   return( ret);  },

 // _m = module parsed description object
 check_features: function( _rules, _m) {
   var r_a = [];
   var r_d = [];
   var v = '';
   if ( typeof _m.req_feature == 'undefined') return( true);
   // check for acceptable form-factor
   v = _m.req_feature.toLowerCase();
//console.log( 'checking:'+v);
   var ret = _rules.any;
//console.log( 'ret0 ' + v + ':' + ret);
   for ( var i = 0; i < _rules.seqs_a.length; i++) {
      var cr = _rules.seqs_a[i];
//console.log( 'v: ' + v + '==' + cr.r);
      if ( v == cr.r) ret = ( cr.s == '-' ? false : true);
   }
//console.log( 'ret2 ' + v + ':' + ret);
   return( ret);  },

 // _m = module parsed description object
 check_lines: function( _lines, _m, _from, _to, _r, _msgs) {
   var linesa = _lines.split( ' ');
   if ( _r != null) _r.empty();
   // check 4 lines
//console.log( 'lines:' + _lines + ' from:' + _from);
   for ( var i = _from + 1; i < _to + 1; i++) {
     var bline = linesa[( i - 1)];
     var mline = _m.get( ( 'line' + i));
     var l = sock_limits.check_lines_1( bline, mline);
//console.log( _m.get('name') + ' check l#' + i + ' ' + bline + '==' + mline + ' r:' + l.state + '(' + l.msg + ')');
     if ( l.state <  0) _r.set(i,true);		// store not available line
     if ( l.state == 0 && l.msg.length > 0) _msgs.set( i, l.msg);
   }
   // false if there are unavalable lines on board that is required by module
   if ( _r.getKeys().length > 0) return( false);
   return( true);  },

 // _bline - one board line
 // _mline - one module line
 // _r - return { state: -1(can't)/0(opt)/1(can), msg: 'message, comment'}
 check_lines_1: function( _bline, _mline) {
   var ret = { 'state':-1, 'msg': 'undefined' };
   if ( typeOf( _bline) == 'null') {  ret.msg = ':is null on board';   return( ret);  }
   if ( _bline == '') {  ret.msg = ':empty str!?';  return( ret);  }
   var bline = _bline.toUpperCase();
   if ( typeOf( _mline) == 'null') _mline = 'Y';
   var mline = _mline.toUpperCase();
   switch ( mline[ 0]) {
     case 'N':		// module does not require line
       ret.state = 1;  ret.msg = '';
       break;
     case 'O':		// module can use line (message)
       ret.state = 0;  ret.msg = '';
       if ( bline[ 0] == 'N') ret.msg = _mline.substring( mline.indexOf( ' ') + 2, mline.length - 1);
       // add msg
       break;
     case 'Y':		// module require board line
       ret.msg = '';
       if ( bline[ 0] == 'N') ret.state = -1;
       else ret.state = 1;
       break;
   }
   return( ret);  },

 // _m = module parsed description object
 check_serial: function( _serial, _m) {
   if ( typeOf( _m.serial) != 'null' && _m.serial[ 0] == 'O') return( true);
   if ( dv_parse.get_bool( _m.serial, false) && _serial == 'N') return( false);
   return( true);  },
 // _m = module parsed description object
 check_interrupt: function( _int, _m) {
   if ( typeOf( _m.interrupt) != 'null' && _m.interrupt[ 0] == 'O') return( true);
   if ( dv_parse.get_bool( _m.interrupt, false) && _int == 'N') return( false);
   return( true);  },
 // _m = module parsed description object
 check_poe: function( _poe, _m) {
   if ( typeOf( _m.poe) != 'null' && _m.poe[ 0] == 'O') return( true);
   if ( dv_parse.get_bool( _m.poe, false) && _poe == 'N') return( false);
   return( true);  },

 // _struct is whole project parsed part
 check_mates: function( _m, _mcell, _r) {
   var ret = new Hash({'ok':true,'msg':''});
//console.log( 'check_mates()');
//console.log( _m);
//console.log( _mcell);
//console.log( _r);
   if ( typeof _m.form == 'undefined') return( ret);
   var doc = dv_svg.get_doc( dv_board.cur_board);
   if ( doc == null) return( ret);
   var angle = doc.rootElement.x_get_angle( _mcell);
//console.log(angle);
   var needs = sock_limits.form_needs( _m.form, angle);
   var xy = sock_limits.get_phy_pos( _mcell);
// invert case of bug: U goes Below, B goes Up
   var plus_U = ( needs.get( 'U') ? needs.get( 'U') : 0) - 1;
   var plus_B = ( needs.get( 'B') ? needs.get( 'B') : 0) - 1;
//   var plus_U = ( needs.get( 'U') ? needs.get( 'U') : 0) + 1;
//   var plus_B = ( needs.get( 'B') ? needs.get( 'B') : 0) + 1;
//if ( angle ==  90 && plus_U > 0) plus_U = -plus_U;
//if ( angle ==  90 && plus_B > 0) plus_B = -plus_B;
//if ( angle == 270 && plus_U > 0) plus_U = -plus_U;
//if ( angle == 270 && plus_B > 0) plus_B = -plus_B;
//console.log( 'needs:');
//console.log( needs);
// new
   var plus_L = ( needs.get( 'L') ? needs.get( 'L') : 0);
   var plus_R = ( needs.get( 'R') ? needs.get( 'R') : 0);
// new /
   var c_U = sock_limits.get_phy_xy( xy.get( 'x'), xy.get( 'y') - plus_U);
   var c_B = sock_limits.get_phy_xy( xy.get( 'x'), xy.get( 'y') + plus_B);
// new
   var c_LU = sock_limits.get_phy_xy( xy.get( 'x') - plus_L, xy.get( 'y'));
   var c_LU = sock_limits.get_phy_xy( xy.get( 'x') - plus_L, xy.get( 'y') - plus_U);
   var c_LB = sock_limits.get_phy_xy( xy.get( 'x') - plus_L, xy.get( 'y') + plus_B);
   var c_R = sock_limits.get_phy_xy( xy.get( 'x') + plus_R, xy.get( 'y'));
   var c_RU = sock_limits.get_phy_xy( xy.get( 'x') + plus_R, xy.get( 'y') - plus_U);
   var c_RB = sock_limits.get_phy_xy( xy.get( 'x') + plus_R, xy.get( 'y') + plus_B);
// new /
   // check up 'mates'
   var strong_mates = false;
   var mm = null;
   if ( typeOf( _m.mates) != 'null') mm = _m.mates;
   else if ( typeOf( _m.requires) != 'null') {  mm = _m.requires;  strong_mates = true;  }
   if ( mm == null) return( ret);
   var acl = new rules0();
   sock_limits.parse_accepts( mm, acl);
   var t = '';
   var nU = dv_board.cell_busy_with( c_U);
//console.log( 'c_U:' + c_U + ' =' + nU);
   sock_limits.check_mates_pair( true, _m, _mcell, acl, nU, c_U, _r, ret);
   var nD = dv_board.cell_busy_with( c_B);
//console.log( 'c_B:' + c_B + ' =' + nD);
   sock_limits.check_mates_pair( true, _m, _mcell, acl, nD, c_B, _r, ret);
   if ( !ret.ok) return( ret);
   if ( strong_mates && nU == null && nD == null) {  // nothing upstairs
     var cc = ( ( c_U ? c_U : c_B) + '').toUpperCase();
     if ( cc == '') cc = '';
     t  = 'Tibbit #' + _m.name + ' in socket ' + _mcell.toUpperCase() + ' requires socket ';
     t += cc;
     t += ' to be populated with a suitable Tibbit as well.';
     if ( _r) {  dv_calc_cons.add( t);  dv_board.r_set(_r,'ERR',t);  }
   }
   // check left or right part of 2-cells wide module
// new
   mm = null;
   if ( typeOf( _m.mates2) != 'null') mm = _m.mates2;
   else if ( typeOf( _m.requires2) != 'null') {  mm = _m.requires2;  strong_mates = true;  }
   if ( mm == null) return( ret);
   acl = new rules0();
   sock_limits.parse_accepts( mm, acl);
   if ( !ret.ok) return( ret);
//console.log( 'c_RU:' + c_RU + ' c_RB:' + c_RB);
   if ( plus_R > 0) {
     var nR = null;
     nR = dv_board.cell_busy_with( c_RU);
     sock_limits.check_mates_pair( true, _m, c_R, acl, nR, c_RU, _r, ret);
     nR = dv_board.cell_busy_with( c_RB);
     sock_limits.check_mates_pair( true, _m, c_R, acl, nR, c_RB, _r, ret);
   }
   if ( !ret.ok) return( ret);
   if ( plus_L > 0) {
     var nL = null;
     nL = dv_board.cell_busy_with( c_LU);
     sock_limits.check_mates_pair( true, _m, c_R, acl, nL, c_LU, _r, ret);
     nL = dv_board.cell_busy_with( c_LB);
     sock_limits.check_mates_pair( true, _m, c_R, acl, nL, c_LB, _r, ret);
   }
//   console.log( _m.name + ' c_L:' + c_L + '(' + plus_L + ') c_R:' + c_R + '(' + plus_R + ')');
//   console.log( ret);
// new /
   return( ret);
 },

 // _strong - strong check
 // _m - current module
 // _mC - current module cell
 // _acl - current module (_m) acl
 // _mp - nextdoor module (pair)
 // _mpC - nextdoor module (pair) cell
 // _r - return data
 check_mates_pair: function( _strong, _m, _mC, _acl, _mp, _mpC, _r, _ret) {
   var t = '';
   if ( typeOf( _mp) == 'null') return( true);
   if ( _mp.pcell == _mC) return( true);
   var fp = find_FN( FILES, _mp.file);
   if ( typeOf( fp) == 'null') return( true);
   if ( typeOf( fp.parsed) == 'null') return( true);
//console.log( _m.name + ' f:' + _m.form + ' _mC:' + _mC + ' check pairCell:' + _mpC);
   var fpP = fp.parsed;
   if ( sock_limits.check_accepts( _acl, fpP)) return( true);
   t = 'Tibbit #' + _m.name + ' at socket ' + _mC.toUpperCase() + ' does not mate with Tibbit #' + fpP.name + ' at socket ' + _mpC.toUpperCase();
   tr = 'Placing this Tibbit at socket ' + _mC.toUpperCase() + ' will conflict with Tibbit #' + fpP.name + ' at socket ' + _mpC.toUpperCase();
   if ( _r) {  dv_calc_cons.add( t);  dv_board.r_set(_r,'ERR',t);  }
   if ( _strong) {  _ret.ok = false;  _ret.msg = tr;  }
   return( _ret.ok);
 },

 // _m = module parsed description object
 check_module_border: function( _sid, _m) {
   var obj = dv_board.cur_board;
   var doc = dv_svg.get_doc( obj);
   var angle = doc.rootElement.x_get_angle( _sid);
   if ( typeof _m.form == 'undefined') {
     dv_cons.add( 'check_free_near: No form!');
     return( false);  }
   var form = _m.form.toLowerCase();
   var needs = sock_limits.form_needs( form, angle);
   // if no free cells requirements
   if ( needs.getLength() < 1) return( true);
//console.log( 'check_module_border(_sid='+_sid+'):');
   // find (x,y) index of target cell
   var xy = sock_limits.get_phy_pos( _sid);
   var s_cpos_x = xy.get( 'x');
   var s_cpos_y = xy.get( 'y');
//console.log( 'cpos_x:' + s_cpos_x + ' cpos_y:' + s_cpos_y);
   // cell not found
   if ( s_cpos_x < 0 || s_cpos_y < 0) {
     dv_cons.add( 'socket ' + _sid + ' not found on the board');
     return( false);  }
   // check!
   var ka = needs.getKeys();
   var d = null;
   var v = 0;
   for ( var i = 0; i < ka.length; i++) {
     d = ka[i]; v = needs.get(d);
     var x = sock_limits.get_near_state( _sid, s_cpos_x, s_cpos_y, d, v);
     // if no cell on some direction, but module requires it
//     if ( x == 1) return( false);
     if ( x == 1) {
//console.log( 'no cell at cpos_x:' + s_cpos_x + ' cpos_y:' + s_cpos_y + ' d:'+d + ' v:'+v);
       return( false);  }
   }
   return( true);  },

 // 0 - free, 1 - no cell, 2 - busy
 // _d - direction
 // _v - vectorN
 get_near_state: function( _sid, _x, _y, _d, _v) {
   var m_x = 0;
   var m_y = 0;
   var v = _v;
   var n = null;
   var near_busy = null;
   while ( v > 0) {
     v--;
     if ( _d == 'L') m_x--;
     if ( _d == 'R') m_x++;
     if ( _d == 'B') m_y--;
     if ( _d == 'U') m_y++;
     n = sock_limits.get_phy_xy( _x + m_x, _y + m_y);
     if ( n == null || n == 'xxx') {
//       dv_cons.add( 'no neighbor socket (' + _x + ' off ' + m_x + ':' + _y + ' off ' + m_y + ' (' + _d + ') exist');
       return( 1);  }
     near_busy = dv_board.cell_busy_with( n);
     if ( near_busy != null) {
//       dv_cons.add( 'socket (' + _x + ' off ' + m_x + ':' + _y + ' off ' + m_y + ') (dir:' + _d + ') is busy');
       return( 2);  }
   }
   return( 0);  },

 get_phy_xy: function( _x, _y) {
   if ( _x < 0) return( null);
   if ( _y < 0) return( null);
   if ( dv_board.phy_layout.length <= _y) return( null);
   var row = dv_board.phy_layout[_y];
   if ( row.length <= _x) return( null);
   var r = row[_x];
//   if ( r == 'xxx') return( null);
   return( r);
 },

 get_phy_pos: function( _sid) {
   var xy = new Hash();
   var s_cpos_x = -1;
   var s_cpos_y = -1;
   for ( var i = 0; i < dv_board.phy_layout.length; i++) {
     var r = dv_board.phy_layout[i];
     var found = false;
     for ( var j = 0; j < r.length; j++) {
       if ( r[j] != _sid) continue;
       s_cpos_x = j;  found = true;  break;
     }
     if ( !found) continue;
     s_cpos_y = i;  break;
   }
   xy.set( 'x', s_cpos_x);
   xy.set( 'y', s_cpos_y);
   return( xy);
 },

 form_needs: function( _form, _angle) {
   var needs = new Hash();
   var d = null;
   var need = 0;
   d = 'L';
   need = sock_limits.form_needs_dir( _form, d);
   if ( need > 0) needs.set( sock_limits.dir_rotate( d, _angle), need);
   d = 'R';
   need = sock_limits.form_needs_dir( _form, d);
   if ( need > 0) needs.set( sock_limits.dir_rotate( d, _angle), need);
   d = 'U';
   need = sock_limits.form_needs_dir( _form, d);
   if ( need > 0) needs.set( sock_limits.dir_rotate( d, _angle), need);
   d = 'B';
   need = sock_limits.form_needs_dir( _form, d);
   if ( need > 0) needs.set( sock_limits.dir_rotate( d, _angle), need);
   return( needs);
 },

 // _dir - direction ('L', 'R', 'U', 'B')
 form_needs_dir: function( _form, _dir) {
   var form = new String( _form).concat();
   var needs = 0;
   switch ( form.toLowerCase()) {
     case 'c1': break;
     case 'c2':		// wide connector
       if ( _dir == 'B') needs = 1;
       break;
     case 'h1':		// tall module
     case 'h1s':
       // h1 needs +1 cell up (R->U see dir_rotate())
       if ( _dir == 'R') needs = 1;
       break;
     case 'h2':		// tall wide module
     case 'h2s':
       // h2 needs +1 cell up & +1 cell right (R->U,B->R see dir_rotate())
       if ( _dir == 'R') needs = 1;
//       if ( _dir == 'L') needs = 1;
       if ( _dir == 'B') needs = 1;
       break;
     case 'm1s':
     case 'm1t':
       break;
     case 'm2s':	// wide module
     case 'm2t':
       if ( _dir == 'B') needs = 1;
       break;
//     case 'ga1000': break;
     default:
       break;
   }
   return( needs);
 },

 dir_rotate: function( _dir, _angle) {
   var TR = new Hash();
   var tra = null;
   tra = new Hash({'L':'U','R':'B','U':'R','B':'L'});
   TR.set(90,tra);
   tra = new Hash({'L':'B','R':'U','U':'L','B':'R'});
   TR.set(270,tra);
   var c = TR.get( _angle);
   if ( !c) return( _dir);
   return( c.get(_dir));
 }

});
