var NS_SVG = "http://www.w3.org/2000/svg";
var NS_XLINK = "http://www.w3.org/1999/xlink";
var BASE = 'txt_Graphics/';
var TIBBIT_START_ANGLE = 90;
var TIBBIT_EL_ID_SFX = '-attached';
var G_WHOLE_ID = 'whole_board';

// where document loaded to? preview or workspace
var my_workspace = null;

function x_set_workspace( _type) {  my_workspace = _type;  }
function x_get_workspace( _type) {  return( my_workspace);  }

function dv_getA( _el, _attr) {
 if ( !_el) return( '');
 var r = _el.getAttribute( _attr);
 if ( r == null) return( '');
 return( r);  }

// get attribute and check parent for it
function dv_getAP( _el, _attr) {
 if ( !_el) return( '');
 var r = _el.getAttribute( _attr);
 if ( r == null) r = _el.parentNode.getAttribute( _attr);
 if ( r == null) return( '');
 return( r);  }

function s2f( _s) {  return( _s.replace( new RegExp( "s", 'g'), 'f'));  }

function x_show( _el) {
// if ( my_workspace == null) return;
 var el = document.getElementById( s2f( _el.id));
 /*if ( el) */el.setAttribute( 'visibility', 'visible');  }
function x_hide( _el) {
// if ( my_workspace == null) return;
 var el = document.getElementById( s2f( _el.id));
 /*if ( el) */el.setAttribute( 'visibility', 'hidden');  }

function get_shift( _el, _coord, _ref, _angle) {
 var shift = 0;
 var shift_var = 'tib_shift' + _coord;
 // get shift attribute from parent <g
 var tib_shift = dv_getAP( _el, shift_var);
 if ( tib_shift != '') shift += parseFloat( tib_shift);
 // get devs definition shift attribute
 if ( _ref[0] != '#') return( shift);
 var devs_id = _ref.substring( 1);
 var dev_e = document.getElementById( devs_id);
 if ( !dev_e) return( shift);
 var dev_e_shift = dv_getAP( dev_e, shift_var);
 if ( dev_e_shift == '') return( shift);
 // plus or minus - depends on rotation angle
 if ( _angle == TIBBIT_START_ANGLE) shift += parseFloat( dev_e_shift);
 else shift -= parseFloat( dev_e_shift);
 return( shift); }

function x_get_angle( _sid) {
 var el = document.getElementById( _sid);
 var tib_rot = dv_getAP( el, 'tib_rot');
 var rotate_angle = TIBBIT_START_ANGLE;
 if ( tib_rot != '') rotate_angle += parseFloat( tib_rot);
 return( rotate_angle);
}

function x_add( _file, _form, _el) {
 var rotate_angle = x_get_angle( _el.id);
 var href = null;
 var root = document.rootElement;
 var ne = null;
 var doclone = true;
 var new_el_id = _el.id + TIBBIT_EL_ID_SFX;
 // this will load template into "devs" if needed
 href = dv_svg_I.get_tib_url( document, _form);
 var cloneD = null;
 if ( doclone && href[ 0] == '#') {
   var t = dv_svg_I.get_dev_ref_name( _form);
   var addn = '-' + _el.id + '-c';
   cloneD = dv_svg_I.devs2dom_clone( document, _form, t + addn);
   if ( cloneD) href += addn;
 }
 ne = document.createElementNS( NS_SVG, "use");
 if ( !ne) return;
 ne.setAttributeNS( NS_XLINK, "xlink:href", href);
 ne.setAttribute( "id", new_el_id);
 if ( cloneD) ne.setAttribute( "tib_cloned", cloneD.id);
 // get (0,0) inside cell element
 var coord_el = _el;
 coord_el_id = s2f( _el.id);
 coord_el = document.getElementById( coord_el_id);
 pxy = get_el_point( coord_el, rotate_angle);
 // shift (0,0) according to cell and tibbit settings
 pxy[ 0] += get_shift( _el, 'x', href, rotate_angle)
 pxy[ 1] += get_shift( _el, 'y', href, rotate_angle)
 ne.setAttribute( 'x', pxy[ 0]);
 ne.setAttribute( 'y', pxy[ 1]);
 // rotate around start point
 if ( rotate_angle != 0) {
   ne.setAttribute( "transform", "rotate(" + rotate_angle + "," + pxy[ 0] + "," + pxy[ 1] + ")");
//   ne.setAttribute( "transform", "translate(" + ne_x + "," + ne_y+ ")");
 }
 ne.setAttribute( "onclick", "tibbit_click(this,evt)");
 ne.setAttribute( 'onmouseover', 'tibbit_over(this,evt)');
 ne.setAttribute( 'onmouseout', 'tibbit_out(this,evt)');
// root.appendChild( ne);
 var tmpx = document.getElementById( G_WHOLE_ID);
 if ( !tmpx) root.appendChild( ne);
 else tmpx.appendChild( ne);
 x_setLBL( new_el_id, _file);
 x_setColor( new_el_id, _file);
 x_hide( _el);
 _el.setAttribute( 'onmouseover', '');
 dv_svg_I.on_add( _el.id, _file, _form, rotate_angle);
 return;  }

function get_el_point( _el, _rotate_angle) {
 var ret = [ 0, 0 ];
 switch ( _el.nodeName) {
   case 'rect':
     // (0,0) at top right corner by default
     ret[ 0] = _el.x.baseVal.value + _el.width.baseVal.value;
     ret[ 1] = _el.y.baseVal.value;
     // (0,0) at bottom left corner for 
     if ( _rotate_angle == 270) {
       ret[ 0] = _el.x.baseVal.value;
       ret[ 1] = _el.y.baseVal.value + _el.height.baseVal.value;
     }
     break;
   default:	// different polygons
     ret[ 0] = _el.points.getItem(0).x;
     ret[ 1] = _el.points.getItem(0).y;
     for ( var i = 0; i < _el.points.numberOfItems; i++) {
       if ( _rotate_angle == 270) {
         // (0,0) at bottom left corner for 
         ret[ 0] = Math.min( ret[ 0], _el.points.getItem(i).x);
         ret[ 1] = Math.max( ret[ 1], _el.points.getItem(i).y);
       } else {
         // (0,0) at top right corner by default
         ret[ 0] = Math.max( ret[ 0], _el.points.getItem(i).x);
         ret[ 1] = Math.min( ret[ 1], _el.points.getItem(i).y);
       }
     }
     break;
 } // switch /
 return( ret);  }

function x_add_id( _file, _form, _elid) {
 var el = document.getElementById(_elid);
 if ( el == null) return;
 x_add( _file, _form, el);  }

function x_del(_el) {
 var root = document.rootElement;
// get parent element
 var coord_el_id = _el.id.replace( new RegExp( TIBBIT_EL_ID_SFX, 'g'), '');
 var clone_id = dv_getA( _el, 'tib_cloned');
// root.removeChild(_el);
 var tmpx = document.getElementById( G_WHOLE_ID);
 if ( !tmpx) root.removeChild( _el);
 else tmpx.removeChild( _el);
 var devD = null;
 if ( clone_id != '') devD = dv_svg_I.find_in_devs( document, clone_id);
 if ( devD) {
   var p = devD.parentNode;
   p.removeChild( devD);  }
 var coord_el = document.getElementById(coord_el_id);
 coord_el.setAttribute( 'onmouseover', 'x_show(this)');
 // FIXME: if clonned - remove "ID-c" from devs
// notify parent backend
 dv_svg_I.on_del( coord_el_id);
 return;  }

function x_del_id( _elid) {
 var el = document.getElementById( _elid);
 if ( el == null) return;
 x_del( el);
 return;  }

// previous x_act implementation:
function x_act( _el, _evt) {
 x_hide( _el);
 if ( my_workspace == null) return;
 dv_svg_I.sock_click( _el.id, _evt);
 return;  }

// previous x_act implementation:
function tibbit_click( _el, _evt) {
 var id = _el.id.replace( new RegExp( TIBBIT_EL_ID_SFX, 'g'), '');
 if ( my_workspace == null) return;
 dv_svg_I.sock_click( id, _evt);
 return;  }

function tibbit_over( _el, _evt) {
 var id = _el.id.replace( new RegExp( TIBBIT_EL_ID_SFX, 'g'), '');
 if ( my_workspace == null) return;
 // don't need for now. But I like it
// dv_svg_I.sock_tibbit_over( id, _evt);
 return;  }
function tibbit_out( _el, _evt) {
 var id = _el.id.replace( new RegExp( TIBBIT_EL_ID_SFX, 'g'), '');
 if ( my_workspace == null) return;
 // don't need for now. But I like it
// dv_svg_I.sock_tibbit_out( id, _evt);
 return;  }

function x_setLBL( _elid, _file) {
 var el = document.getElementById( _elid);
 if ( !el) return;
 var clone_id = dv_getA( el, 'tib_cloned');
 if ( clone_id != '') el = document.getElementById( clone_id);
 if ( !el) return;
 var lbls = dv_svg_I.get_labels_txt( _file);
 dv_svg_I.set_labels( el, lbls);
 return;  }

function x_setColor( _elid, _file) {
 var el = document.getElementById( _elid);
 if ( !el) return;
 var clone_id = dv_getA( el, 'tib_cloned');
 if ( clone_id != '') el = document.getElementById( clone_id);
 if ( !el) return;
 var c = dv_svg_I.get_colors_txt( _file);
 dv_svg_I.set_colors( el, 'moduleColor', 'moduleColor_' + c);
 return;  }

document.rootElement.x_get_angle = x_get_angle;
document.rootElement.x_add_id = x_add_id;
document.rootElement.x_del_id = x_del_id;
document.rootElement.x_setLBL = x_setLBL;
document.rootElement.x_setColor = x_setColor;
document.rootElement.x_set_workspace = x_set_workspace;
document.rootElement.x_get_workspace = x_get_workspace;
if ( typeof phy_layout != 'undefined') {
  document.rootElement.phy_layout = phy_layout;
}
